//
// Generator of src/frontend/cxx-gccbuiltins-ia32.h for gcc
//
// Use make generate_builtins_ia32 (at the tp level) to compile this file
//

#include <iostream>
#include <sstream>
#include "builtins-common.hpp"

// --------------------------------------------
// Specific generators for IA32
// --------------------------------------------

#define GENERATE_VECTOR(N, T) \
template <>\
struct generate_type<__attribute__((vector_size(N))) T>\
{\
    static const int size = N;\
    typedef T element_type;\
\
    static std::string g() \
    {\
        std::stringstream ss;\
\
        ss << "get_vector_type_by_bytes(" << generate_type<element_type>::g() << ", " << N << ")";\
\
        return ss.str();\
    }\
};\

#define GENERATE_MANY(T) \
   GENERATE_VECTOR(8, T) \
   GENERATE_VECTOR(16, T) \
   GENERATE_VECTOR(32, T) \
   GENERATE_VECTOR(64, T)


GENERATE_MANY(int)
GENERATE_MANY(signed char)
GENERATE_MANY(char)
GENERATE_MANY(short)
GENERATE_MANY(long)
GENERATE_MANY(long long)

GENERATE_MANY(unsigned int)
GENERATE_MANY(unsigned char)
GENERATE_MANY(unsigned short)
GENERATE_MANY(unsigned long)
GENERATE_MANY(unsigned long long)

GENERATE_MANY(float)
GENERATE_MANY(double)

// --------------------------------------------
// End of specific generators for IA32
// --------------------------------------------

#define END

#define VECTOR_INTRINSICS_LIST \
VECTOR_INTRIN(__builtin_ia32_4fmaddps) \
VECTOR_INTRIN(__builtin_ia32_4fmaddps_mask) \
VECTOR_INTRIN(__builtin_ia32_4fmaddss) \
VECTOR_INTRIN(__builtin_ia32_4fmaddss_mask) \
VECTOR_INTRIN(__builtin_ia32_4fnmaddps) \
VECTOR_INTRIN(__builtin_ia32_4fnmaddps_mask) \
VECTOR_INTRIN(__builtin_ia32_4fnmaddss) \
VECTOR_INTRIN(__builtin_ia32_4fnmaddss_mask) \
VECTOR_INTRIN(__builtin_ia32_addcarryx_u32) \
VECTOR_INTRIN(__builtin_ia32_addcarryx_u64) \
VECTOR_INTRIN(__builtin_ia32_addpd) \
VECTOR_INTRIN(__builtin_ia32_addpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_addpd256) \
VECTOR_INTRIN(__builtin_ia32_addpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_addpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_addps) \
VECTOR_INTRIN(__builtin_ia32_addps128_mask) \
VECTOR_INTRIN(__builtin_ia32_addps256) \
VECTOR_INTRIN(__builtin_ia32_addps256_mask) \
VECTOR_INTRIN(__builtin_ia32_addps512_mask) \
VECTOR_INTRIN(__builtin_ia32_addsd) \
VECTOR_INTRIN(__builtin_ia32_addsd_round) \
VECTOR_INTRIN(__builtin_ia32_addss) \
VECTOR_INTRIN(__builtin_ia32_addss_round) \
VECTOR_INTRIN(__builtin_ia32_addsubpd) \
VECTOR_INTRIN(__builtin_ia32_addsubpd256) \
VECTOR_INTRIN(__builtin_ia32_addsubps) \
VECTOR_INTRIN(__builtin_ia32_addsubps256) \
VECTOR_INTRIN(__builtin_ia32_aesdec128) \
VECTOR_INTRIN(__builtin_ia32_aesdeclast128) \
VECTOR_INTRIN(__builtin_ia32_aesenc128) \
VECTOR_INTRIN(__builtin_ia32_aesenclast128) \
VECTOR_INTRIN(__builtin_ia32_aesimc128) \
VECTOR_INTRIN(__builtin_ia32_aeskeygenassist128) \
VECTOR_INTRIN(__builtin_ia32_alignd128_mask) \
VECTOR_INTRIN(__builtin_ia32_alignd256_mask) \
VECTOR_INTRIN(__builtin_ia32_alignd512_mask) \
VECTOR_INTRIN(__builtin_ia32_alignq128_mask) \
VECTOR_INTRIN(__builtin_ia32_alignq256_mask) \
VECTOR_INTRIN(__builtin_ia32_alignq512_mask) \
VECTOR_INTRIN(__builtin_ia32_andnotsi256) \
VECTOR_INTRIN(__builtin_ia32_andnpd) \
VECTOR_INTRIN(__builtin_ia32_andnpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_andnpd256) \
VECTOR_INTRIN(__builtin_ia32_andnpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_andnpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_andnps) \
VECTOR_INTRIN(__builtin_ia32_andnps128_mask) \
VECTOR_INTRIN(__builtin_ia32_andnps256) \
VECTOR_INTRIN(__builtin_ia32_andnps256_mask) \
VECTOR_INTRIN(__builtin_ia32_andnps512_mask) \
VECTOR_INTRIN(__builtin_ia32_andpd) \
VECTOR_INTRIN(__builtin_ia32_andpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_andpd256) \
VECTOR_INTRIN(__builtin_ia32_andpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_andpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_andps) \
VECTOR_INTRIN(__builtin_ia32_andps128_mask) \
VECTOR_INTRIN(__builtin_ia32_andps256) \
VECTOR_INTRIN(__builtin_ia32_andps256_mask) \
VECTOR_INTRIN(__builtin_ia32_andps512_mask) \
VECTOR_INTRIN(__builtin_ia32_andsi256) \
VECTOR_INTRIN(__builtin_ia32_bextr_u32) \
VECTOR_INTRIN(__builtin_ia32_bextr_u64) \
VECTOR_INTRIN(__builtin_ia32_bextri_u32) \
VECTOR_INTRIN(__builtin_ia32_bextri_u64) \
VECTOR_INTRIN(__builtin_ia32_blendmb_128_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmb_256_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmb_512_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmd_128_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmd_256_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmd_512_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmpd_128_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmpd_256_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmpd_512_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmps_128_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmps_256_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmps_512_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmq_128_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmq_256_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmq_512_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmw_128_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmw_256_mask) \
VECTOR_INTRIN(__builtin_ia32_blendmw_512_mask) \
VECTOR_INTRIN(__builtin_ia32_blendpd) \
VECTOR_INTRIN(__builtin_ia32_blendpd256) \
VECTOR_INTRIN(__builtin_ia32_blendps) \
VECTOR_INTRIN(__builtin_ia32_blendps256) \
VECTOR_INTRIN(__builtin_ia32_blendvpd) \
VECTOR_INTRIN(__builtin_ia32_blendvpd256) \
VECTOR_INTRIN(__builtin_ia32_blendvps) \
VECTOR_INTRIN(__builtin_ia32_blendvps256) \
VECTOR_INTRIN(__builtin_ia32_broadcastf32x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastf32x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastf32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastf32x4_512) \
VECTOR_INTRIN(__builtin_ia32_broadcastf32x8_512_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastf64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastf64x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastf64x4_512) \
VECTOR_INTRIN(__builtin_ia32_broadcasti32x2_128_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti32x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti32x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti32x4_512) \
VECTOR_INTRIN(__builtin_ia32_broadcasti32x8_512_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti64x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcasti64x4_512) \
VECTOR_INTRIN(__builtin_ia32_broadcastmb128) \
VECTOR_INTRIN(__builtin_ia32_broadcastmb256) \
VECTOR_INTRIN(__builtin_ia32_broadcastmb512) \
VECTOR_INTRIN(__builtin_ia32_broadcastmw128) \
VECTOR_INTRIN(__builtin_ia32_broadcastmw256) \
VECTOR_INTRIN(__builtin_ia32_broadcastmw512) \
VECTOR_INTRIN(__builtin_ia32_broadcastsd256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastsd512) \
VECTOR_INTRIN(__builtin_ia32_broadcastss128_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastss256_mask) \
VECTOR_INTRIN(__builtin_ia32_broadcastss512) \
VECTOR_INTRIN(__builtin_ia32_bsrdi) \
VECTOR_INTRIN(__builtin_ia32_bsrsi) \
VECTOR_INTRIN(__builtin_ia32_bzhi_di) \
VECTOR_INTRIN(__builtin_ia32_bzhi_si) \
VECTOR_INTRIN(__builtin_ia32_clflush) \
VECTOR_INTRIN(__builtin_ia32_clflushopt) \
VECTOR_INTRIN(__builtin_ia32_clwb) \
VECTOR_INTRIN(__builtin_ia32_clzero) \
VECTOR_INTRIN(__builtin_ia32_cmpb128_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpb256_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpb512_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpeqpd) \
VECTOR_INTRIN(__builtin_ia32_cmpeqps) \
VECTOR_INTRIN(__builtin_ia32_cmpeqsd) \
VECTOR_INTRIN(__builtin_ia32_cmpeqss) \
VECTOR_INTRIN(__builtin_ia32_cmpgepd) \
VECTOR_INTRIN(__builtin_ia32_cmpgeps) \
VECTOR_INTRIN(__builtin_ia32_cmpgtpd) \
VECTOR_INTRIN(__builtin_ia32_cmpgtps) \
VECTOR_INTRIN(__builtin_ia32_cmplepd) \
VECTOR_INTRIN(__builtin_ia32_cmpleps) \
VECTOR_INTRIN(__builtin_ia32_cmplesd) \
VECTOR_INTRIN(__builtin_ia32_cmpless) \
VECTOR_INTRIN(__builtin_ia32_cmpltpd) \
VECTOR_INTRIN(__builtin_ia32_cmpltps) \
VECTOR_INTRIN(__builtin_ia32_cmpltsd) \
VECTOR_INTRIN(__builtin_ia32_cmpltss) \
VECTOR_INTRIN(__builtin_ia32_cmpneqpd) \
VECTOR_INTRIN(__builtin_ia32_cmpneqps) \
VECTOR_INTRIN(__builtin_ia32_cmpneqsd) \
VECTOR_INTRIN(__builtin_ia32_cmpneqss) \
VECTOR_INTRIN(__builtin_ia32_cmpngepd) \
VECTOR_INTRIN(__builtin_ia32_cmpngeps) \
VECTOR_INTRIN(__builtin_ia32_cmpngtpd) \
VECTOR_INTRIN(__builtin_ia32_cmpngtps) \
VECTOR_INTRIN(__builtin_ia32_cmpnlepd) \
VECTOR_INTRIN(__builtin_ia32_cmpnleps) \
VECTOR_INTRIN(__builtin_ia32_cmpnlesd) \
VECTOR_INTRIN(__builtin_ia32_cmpnless) \
VECTOR_INTRIN(__builtin_ia32_cmpnltpd) \
VECTOR_INTRIN(__builtin_ia32_cmpnltps) \
VECTOR_INTRIN(__builtin_ia32_cmpnltsd) \
VECTOR_INTRIN(__builtin_ia32_cmpnltss) \
VECTOR_INTRIN(__builtin_ia32_cmpordpd) \
VECTOR_INTRIN(__builtin_ia32_cmpordps) \
VECTOR_INTRIN(__builtin_ia32_cmpordsd) \
VECTOR_INTRIN(__builtin_ia32_cmpordss) \
VECTOR_INTRIN(__builtin_ia32_cmppd) \
VECTOR_INTRIN(__builtin_ia32_cmppd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cmppd256) \
VECTOR_INTRIN(__builtin_ia32_cmppd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cmppd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpps) \
VECTOR_INTRIN(__builtin_ia32_cmpps128_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpps256) \
VECTOR_INTRIN(__builtin_ia32_cmpps256_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpps512_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpsd) \
VECTOR_INTRIN(__builtin_ia32_cmpsd_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpss) \
VECTOR_INTRIN(__builtin_ia32_cmpss_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpunordpd) \
VECTOR_INTRIN(__builtin_ia32_cmpunordps) \
VECTOR_INTRIN(__builtin_ia32_cmpunordsd) \
VECTOR_INTRIN(__builtin_ia32_cmpunordss) \
VECTOR_INTRIN(__builtin_ia32_cmpw128_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpw256_mask) \
VECTOR_INTRIN(__builtin_ia32_cmpw512_mask) \
VECTOR_INTRIN(__builtin_ia32_comieq) \
VECTOR_INTRIN(__builtin_ia32_comige) \
VECTOR_INTRIN(__builtin_ia32_comigt) \
VECTOR_INTRIN(__builtin_ia32_comile) \
VECTOR_INTRIN(__builtin_ia32_comilt) \
VECTOR_INTRIN(__builtin_ia32_comineq) \
VECTOR_INTRIN(__builtin_ia32_comisdeq) \
VECTOR_INTRIN(__builtin_ia32_comisdge) \
VECTOR_INTRIN(__builtin_ia32_comisdgt) \
VECTOR_INTRIN(__builtin_ia32_comisdle) \
VECTOR_INTRIN(__builtin_ia32_comisdlt) \
VECTOR_INTRIN(__builtin_ia32_comisdneq) \
VECTOR_INTRIN(__builtin_ia32_compressdf128_mask) \
VECTOR_INTRIN(__builtin_ia32_compressdf256_mask) \
VECTOR_INTRIN(__builtin_ia32_compressdf512_mask) \
VECTOR_INTRIN(__builtin_ia32_compressdi128_mask) \
VECTOR_INTRIN(__builtin_ia32_compressdi256_mask) \
VECTOR_INTRIN(__builtin_ia32_compressdi512_mask) \
VECTOR_INTRIN(__builtin_ia32_compresssf128_mask) \
VECTOR_INTRIN(__builtin_ia32_compresssf256_mask) \
VECTOR_INTRIN(__builtin_ia32_compresssf512_mask) \
VECTOR_INTRIN(__builtin_ia32_compresssi128_mask) \
VECTOR_INTRIN(__builtin_ia32_compresssi256_mask) \
VECTOR_INTRIN(__builtin_ia32_compresssi512_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoredf128_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoredf256_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoredf512_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoredi128_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoredi256_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoredi512_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoresf128_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoresf256_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoresf512_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoresi128_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoresi256_mask) \
VECTOR_INTRIN(__builtin_ia32_compressstoresi512_mask) \
VECTOR_INTRIN(__builtin_ia32_crc32di) \
VECTOR_INTRIN(__builtin_ia32_crc32hi) \
VECTOR_INTRIN(__builtin_ia32_crc32qi) \
VECTOR_INTRIN(__builtin_ia32_crc32si) \
VECTOR_INTRIN(__builtin_ia32_cvtb2mask128) \
VECTOR_INTRIN(__builtin_ia32_cvtb2mask256) \
VECTOR_INTRIN(__builtin_ia32_cvtb2mask512) \
VECTOR_INTRIN(__builtin_ia32_cvtd2mask128) \
VECTOR_INTRIN(__builtin_ia32_cvtd2mask256) \
VECTOR_INTRIN(__builtin_ia32_cvtd2mask512) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2pd) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2pd256) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2ps) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2ps128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2ps256) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtdq2ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2b128) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2b256) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2b512) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2d128) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2d256) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2d512) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2q128) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2q256) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2q512) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2w128) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2w256) \
VECTOR_INTRIN(__builtin_ia32_cvtmask2w512) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2dq) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2dq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2dq256) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2dq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2dq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2pi) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2ps) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2ps256) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2ps_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2qq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2qq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2qq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2udq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2udq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2udq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2uqq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2uqq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpd2uqq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtpi2pd) \
VECTOR_INTRIN(__builtin_ia32_cvtpi2ps) \
VECTOR_INTRIN(__builtin_ia32_cvtps2dq) \
VECTOR_INTRIN(__builtin_ia32_cvtps2dq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2dq256) \
VECTOR_INTRIN(__builtin_ia32_cvtps2dq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2dq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2pd) \
VECTOR_INTRIN(__builtin_ia32_cvtps2pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2pd256) \
VECTOR_INTRIN(__builtin_ia32_cvtps2pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2pi) \
VECTOR_INTRIN(__builtin_ia32_cvtps2qq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2qq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2qq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2udq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2udq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2udq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2uqq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2uqq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtps2uqq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtq2mask128) \
VECTOR_INTRIN(__builtin_ia32_cvtq2mask256) \
VECTOR_INTRIN(__builtin_ia32_cvtq2mask512) \
VECTOR_INTRIN(__builtin_ia32_cvtqq2pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtqq2pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtqq2pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtqq2ps128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtqq2ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtqq2ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtsd2si) \
VECTOR_INTRIN(__builtin_ia32_cvtsd2si64) \
VECTOR_INTRIN(__builtin_ia32_cvtsd2ss) \
VECTOR_INTRIN(__builtin_ia32_cvtsd2ss_round) \
VECTOR_INTRIN(__builtin_ia32_cvtsi2sd) \
VECTOR_INTRIN(__builtin_ia32_cvtsi2sd64) \
VECTOR_INTRIN(__builtin_ia32_cvtsi2ss) \
VECTOR_INTRIN(__builtin_ia32_cvtsi2ss32) \
VECTOR_INTRIN(__builtin_ia32_cvtsi2ss64) \
VECTOR_INTRIN(__builtin_ia32_cvtsi642sd) \
VECTOR_INTRIN(__builtin_ia32_cvtsi642ss) \
VECTOR_INTRIN(__builtin_ia32_cvtss2sd) \
VECTOR_INTRIN(__builtin_ia32_cvtss2sd_round) \
VECTOR_INTRIN(__builtin_ia32_cvtss2si) \
VECTOR_INTRIN(__builtin_ia32_cvtss2si64) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2dq) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2dq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2dq256) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2dq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2dq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2pi) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2qq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2qq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2qq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2udq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2udq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2udq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2uqq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2uqq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttpd2uqq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2dq) \
VECTOR_INTRIN(__builtin_ia32_cvttps2dq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2dq256) \
VECTOR_INTRIN(__builtin_ia32_cvttps2dq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2dq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2pi) \
VECTOR_INTRIN(__builtin_ia32_cvttps2qq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2qq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2qq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2udq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2udq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2udq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2uqq128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2uqq256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttps2uqq512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvttsd2si) \
VECTOR_INTRIN(__builtin_ia32_cvttsd2si64) \
VECTOR_INTRIN(__builtin_ia32_cvttss2si) \
VECTOR_INTRIN(__builtin_ia32_cvttss2si64) \
VECTOR_INTRIN(__builtin_ia32_cvtudq2pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtudq2pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtudq2pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtudq2ps128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtudq2ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtudq2ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtuqq2pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtuqq2pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtuqq2pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtuqq2ps128_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtuqq2ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtuqq2ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_cvtusi2sd32) \
VECTOR_INTRIN(__builtin_ia32_cvtusi2sd64) \
VECTOR_INTRIN(__builtin_ia32_cvtusi2ss32) \
VECTOR_INTRIN(__builtin_ia32_cvtusi2ss64) \
VECTOR_INTRIN(__builtin_ia32_cvtw2mask128) \
VECTOR_INTRIN(__builtin_ia32_cvtw2mask256) \
VECTOR_INTRIN(__builtin_ia32_cvtw2mask512) \
VECTOR_INTRIN(__builtin_ia32_dbpsadbw128_mask) \
VECTOR_INTRIN(__builtin_ia32_dbpsadbw256_mask) \
VECTOR_INTRIN(__builtin_ia32_dbpsadbw512_mask) \
VECTOR_INTRIN(__builtin_ia32_divpd) \
VECTOR_INTRIN(__builtin_ia32_divpd256) \
VECTOR_INTRIN(__builtin_ia32_divpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_divpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_divpd_mask) \
VECTOR_INTRIN(__builtin_ia32_divps) \
VECTOR_INTRIN(__builtin_ia32_divps256) \
VECTOR_INTRIN(__builtin_ia32_divps256_mask) \
VECTOR_INTRIN(__builtin_ia32_divps512_mask) \
VECTOR_INTRIN(__builtin_ia32_divps_mask) \
VECTOR_INTRIN(__builtin_ia32_divsd) \
VECTOR_INTRIN(__builtin_ia32_divsd_round) \
VECTOR_INTRIN(__builtin_ia32_divss) \
VECTOR_INTRIN(__builtin_ia32_divss_round) \
VECTOR_INTRIN(__builtin_ia32_dppd) \
VECTOR_INTRIN(__builtin_ia32_dpps) \
VECTOR_INTRIN(__builtin_ia32_dpps256) \
VECTOR_INTRIN(__builtin_ia32_emms) \
VECTOR_INTRIN(__builtin_ia32_exp2pd_mask) \
VECTOR_INTRIN(__builtin_ia32_exp2ps_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddf128_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddf128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expanddf256_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddf256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expanddf512_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddf512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expanddi128_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddi128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expanddi256_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddi256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expanddi512_mask) \
VECTOR_INTRIN(__builtin_ia32_expanddi512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloaddf128_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloaddf128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloaddf256_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloaddf256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloaddf512_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloaddf512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloaddi128_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloaddi128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloaddi256_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloaddi256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloaddi512_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloaddi512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloadsf128_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloadsf128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloadsf256_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloadsf256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloadsf512_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloadsf512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloadsi128_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloadsi128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloadsi256_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloadsi256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandloadsi512_mask) \
VECTOR_INTRIN(__builtin_ia32_expandloadsi512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandsf128_mask) \
VECTOR_INTRIN(__builtin_ia32_expandsf128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandsf256_mask) \
VECTOR_INTRIN(__builtin_ia32_expandsf256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandsf512_mask) \
VECTOR_INTRIN(__builtin_ia32_expandsf512_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandsi128_mask) \
VECTOR_INTRIN(__builtin_ia32_expandsi128_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandsi256_mask) \
VECTOR_INTRIN(__builtin_ia32_expandsi256_maskz) \
VECTOR_INTRIN(__builtin_ia32_expandsi512_mask) \
VECTOR_INTRIN(__builtin_ia32_expandsi512_maskz) \
VECTOR_INTRIN(__builtin_ia32_extract128i256) \
VECTOR_INTRIN(__builtin_ia32_extractf32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_extractf32x4_mask) \
VECTOR_INTRIN(__builtin_ia32_extractf32x8_mask) \
VECTOR_INTRIN(__builtin_ia32_extractf64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_extractf64x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_extractf64x4_mask) \
VECTOR_INTRIN(__builtin_ia32_extracti32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_extracti32x4_mask) \
VECTOR_INTRIN(__builtin_ia32_extracti32x8_mask) \
VECTOR_INTRIN(__builtin_ia32_extracti64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_extracti64x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_extracti64x4_mask) \
VECTOR_INTRIN(__builtin_ia32_extrq) \
VECTOR_INTRIN(__builtin_ia32_extrqi) \
VECTOR_INTRIN(__builtin_ia32_femms) \
VECTOR_INTRIN(__builtin_ia32_fixupimmpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmpd128_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmpd256_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmpd512_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmps128_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmps128_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmps256_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmps256_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmps512_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmps512_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmsd_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmsd_maskz) \
VECTOR_INTRIN(__builtin_ia32_fixupimmss_mask) \
VECTOR_INTRIN(__builtin_ia32_fixupimmss_maskz) \
VECTOR_INTRIN(__builtin_ia32_fpclasspd128_mask) \
VECTOR_INTRIN(__builtin_ia32_fpclasspd256_mask) \
VECTOR_INTRIN(__builtin_ia32_fpclasspd512_mask) \
VECTOR_INTRIN(__builtin_ia32_fpclassps128_mask) \
VECTOR_INTRIN(__builtin_ia32_fpclassps256_mask) \
VECTOR_INTRIN(__builtin_ia32_fpclassps512_mask) \
VECTOR_INTRIN(__builtin_ia32_fpclasssd) \
VECTOR_INTRIN(__builtin_ia32_fpclassss) \
VECTOR_INTRIN(__builtin_ia32_fxrstor) \
VECTOR_INTRIN(__builtin_ia32_fxrstor64) \
VECTOR_INTRIN(__builtin_ia32_fxsave) \
VECTOR_INTRIN(__builtin_ia32_fxsave64) \
VECTOR_INTRIN(__builtin_ia32_gather3div2df) \
VECTOR_INTRIN(__builtin_ia32_gather3div2di) \
VECTOR_INTRIN(__builtin_ia32_gather3div4df) \
VECTOR_INTRIN(__builtin_ia32_gather3div4di) \
VECTOR_INTRIN(__builtin_ia32_gather3div4sf) \
VECTOR_INTRIN(__builtin_ia32_gather3div4si) \
VECTOR_INTRIN(__builtin_ia32_gather3div8sf) \
VECTOR_INTRIN(__builtin_ia32_gather3div8si) \
VECTOR_INTRIN(__builtin_ia32_gather3siv2df) \
VECTOR_INTRIN(__builtin_ia32_gather3siv2di) \
VECTOR_INTRIN(__builtin_ia32_gather3siv4df) \
VECTOR_INTRIN(__builtin_ia32_gather3siv4di) \
VECTOR_INTRIN(__builtin_ia32_gather3siv4sf) \
VECTOR_INTRIN(__builtin_ia32_gather3siv4si) \
VECTOR_INTRIN(__builtin_ia32_gather3siv8sf) \
VECTOR_INTRIN(__builtin_ia32_gather3siv8si) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv16sf) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv16si) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv2df) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv2di) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv4df) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv4di) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv4sf) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv4sf256) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv4si) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv4si256) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv8df) \
VECTOR_INTRIN(__builtin_ia32_gatherdiv8di) \
VECTOR_INTRIN(__builtin_ia32_gatherpfdpd) \
VECTOR_INTRIN(__builtin_ia32_gatherpfdps) \
VECTOR_INTRIN(__builtin_ia32_gatherpfqpd) \
VECTOR_INTRIN(__builtin_ia32_gatherpfqps) \
VECTOR_INTRIN(__builtin_ia32_gathersiv16sf) \
VECTOR_INTRIN(__builtin_ia32_gathersiv16si) \
VECTOR_INTRIN(__builtin_ia32_gathersiv2df) \
VECTOR_INTRIN(__builtin_ia32_gathersiv2di) \
VECTOR_INTRIN(__builtin_ia32_gathersiv4df) \
VECTOR_INTRIN(__builtin_ia32_gathersiv4di) \
VECTOR_INTRIN(__builtin_ia32_gathersiv4sf) \
VECTOR_INTRIN(__builtin_ia32_gathersiv4si) \
VECTOR_INTRIN(__builtin_ia32_gathersiv8df) \
VECTOR_INTRIN(__builtin_ia32_gathersiv8di) \
VECTOR_INTRIN(__builtin_ia32_gathersiv8sf) \
VECTOR_INTRIN(__builtin_ia32_gathersiv8si) \
VECTOR_INTRIN(__builtin_ia32_getexppd128_mask) \
VECTOR_INTRIN(__builtin_ia32_getexppd256_mask) \
VECTOR_INTRIN(__builtin_ia32_getexppd512_mask) \
VECTOR_INTRIN(__builtin_ia32_getexpps128_mask) \
VECTOR_INTRIN(__builtin_ia32_getexpps256_mask) \
VECTOR_INTRIN(__builtin_ia32_getexpps512_mask) \
VECTOR_INTRIN(__builtin_ia32_getexpsd128_round) \
VECTOR_INTRIN(__builtin_ia32_getexpss128_round) \
VECTOR_INTRIN(__builtin_ia32_getmantpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_getmantpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_getmantpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_getmantps128_mask) \
VECTOR_INTRIN(__builtin_ia32_getmantps256_mask) \
VECTOR_INTRIN(__builtin_ia32_getmantps512_mask) \
VECTOR_INTRIN(__builtin_ia32_getmantsd_round) \
VECTOR_INTRIN(__builtin_ia32_getmantss_round) \
VECTOR_INTRIN(__builtin_ia32_haddpd) \
VECTOR_INTRIN(__builtin_ia32_haddpd256) \
VECTOR_INTRIN(__builtin_ia32_haddps) \
VECTOR_INTRIN(__builtin_ia32_haddps256) \
VECTOR_INTRIN(__builtin_ia32_hsubpd) \
VECTOR_INTRIN(__builtin_ia32_hsubpd256) \
VECTOR_INTRIN(__builtin_ia32_hsubps) \
VECTOR_INTRIN(__builtin_ia32_hsubps256) \
VECTOR_INTRIN(__builtin_ia32_insert128i256) \
VECTOR_INTRIN(__builtin_ia32_insertf32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_insertf32x4_mask) \
VECTOR_INTRIN(__builtin_ia32_insertf32x8_mask) \
VECTOR_INTRIN(__builtin_ia32_insertf64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_insertf64x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_insertf64x4_mask) \
VECTOR_INTRIN(__builtin_ia32_inserti32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_inserti32x4_mask) \
VECTOR_INTRIN(__builtin_ia32_inserti32x8_mask) \
VECTOR_INTRIN(__builtin_ia32_inserti64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_inserti64x2_512_mask) \
VECTOR_INTRIN(__builtin_ia32_inserti64x4_mask) \
VECTOR_INTRIN(__builtin_ia32_insertps128) \
VECTOR_INTRIN(__builtin_ia32_insertq) \
VECTOR_INTRIN(__builtin_ia32_insertqi) \
VECTOR_INTRIN(__builtin_ia32_kadddi) \
VECTOR_INTRIN(__builtin_ia32_kaddhi) \
VECTOR_INTRIN(__builtin_ia32_kaddqi) \
VECTOR_INTRIN(__builtin_ia32_kaddsi) \
VECTOR_INTRIN(__builtin_ia32_kanddi) \
VECTOR_INTRIN(__builtin_ia32_kandhi) \
VECTOR_INTRIN(__builtin_ia32_kandndi) \
VECTOR_INTRIN(__builtin_ia32_kandnhi) \
VECTOR_INTRIN(__builtin_ia32_kandnqi) \
VECTOR_INTRIN(__builtin_ia32_kandnsi) \
VECTOR_INTRIN(__builtin_ia32_kandqi) \
VECTOR_INTRIN(__builtin_ia32_kandsi) \
VECTOR_INTRIN(__builtin_ia32_kmovb) \
VECTOR_INTRIN(__builtin_ia32_kmovd) \
VECTOR_INTRIN(__builtin_ia32_kmovq) \
VECTOR_INTRIN(__builtin_ia32_kmovw) \
VECTOR_INTRIN(__builtin_ia32_knotdi) \
VECTOR_INTRIN(__builtin_ia32_knothi) \
VECTOR_INTRIN(__builtin_ia32_knotqi) \
VECTOR_INTRIN(__builtin_ia32_knotsi) \
VECTOR_INTRIN(__builtin_ia32_kordi) \
VECTOR_INTRIN(__builtin_ia32_korhi) \
VECTOR_INTRIN(__builtin_ia32_korqi) \
VECTOR_INTRIN(__builtin_ia32_korsi) \
VECTOR_INTRIN(__builtin_ia32_kortestcdi) \
VECTOR_INTRIN(__builtin_ia32_kortestchi) \
VECTOR_INTRIN(__builtin_ia32_kortestcqi) \
VECTOR_INTRIN(__builtin_ia32_kortestcsi) \
VECTOR_INTRIN(__builtin_ia32_kortestzdi) \
VECTOR_INTRIN(__builtin_ia32_kortestzhi) \
VECTOR_INTRIN(__builtin_ia32_kortestzqi) \
VECTOR_INTRIN(__builtin_ia32_kortestzsi) \
VECTOR_INTRIN(__builtin_ia32_ktestcdi) \
VECTOR_INTRIN(__builtin_ia32_ktestchi) \
VECTOR_INTRIN(__builtin_ia32_ktestcqi) \
VECTOR_INTRIN(__builtin_ia32_ktestcsi) \
VECTOR_INTRIN(__builtin_ia32_ktestzdi) \
VECTOR_INTRIN(__builtin_ia32_ktestzhi) \
VECTOR_INTRIN(__builtin_ia32_ktestzqi) \
VECTOR_INTRIN(__builtin_ia32_ktestzsi) \
VECTOR_INTRIN(__builtin_ia32_kunpckdi) \
VECTOR_INTRIN(__builtin_ia32_kunpckhi) \
VECTOR_INTRIN(__builtin_ia32_kunpcksi) \
VECTOR_INTRIN(__builtin_ia32_kxnordi) \
VECTOR_INTRIN(__builtin_ia32_kxnorhi) \
VECTOR_INTRIN(__builtin_ia32_kxnorqi) \
VECTOR_INTRIN(__builtin_ia32_kxnorsi) \
VECTOR_INTRIN(__builtin_ia32_kxordi) \
VECTOR_INTRIN(__builtin_ia32_kxorhi) \
VECTOR_INTRIN(__builtin_ia32_kxorqi) \
VECTOR_INTRIN(__builtin_ia32_kxorsi) \
VECTOR_INTRIN(__builtin_ia32_lddqu) \
VECTOR_INTRIN(__builtin_ia32_lddqu256) \
VECTOR_INTRIN(__builtin_ia32_ldmxcsr) \
VECTOR_INTRIN(__builtin_ia32_lfence) \
VECTOR_INTRIN(__builtin_ia32_llwpcb) \
VECTOR_INTRIN(__builtin_ia32_loadapd128_mask) \
VECTOR_INTRIN(__builtin_ia32_loadapd256_mask) \
VECTOR_INTRIN(__builtin_ia32_loadapd512_mask) \
VECTOR_INTRIN(__builtin_ia32_loadaps128_mask) \
VECTOR_INTRIN(__builtin_ia32_loadaps256_mask) \
VECTOR_INTRIN(__builtin_ia32_loadaps512_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddqu) \
VECTOR_INTRIN(__builtin_ia32_loaddqu256) \
VECTOR_INTRIN(__builtin_ia32_loaddqudi128_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddqudi256_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddqudi512_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddquhi128_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddquhi256_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddquhi512_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddquqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddquqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddquqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddqusi128_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddqusi256_mask) \
VECTOR_INTRIN(__builtin_ia32_loaddqusi512_mask) \
VECTOR_INTRIN(__builtin_ia32_loadhpd) \
VECTOR_INTRIN(__builtin_ia32_loadhps) \
VECTOR_INTRIN(__builtin_ia32_loadlpd) \
VECTOR_INTRIN(__builtin_ia32_loadlps) \
VECTOR_INTRIN(__builtin_ia32_loadupd) \
VECTOR_INTRIN(__builtin_ia32_loadupd128_mask) \
VECTOR_INTRIN(__builtin_ia32_loadupd256) \
VECTOR_INTRIN(__builtin_ia32_loadupd256_mask) \
VECTOR_INTRIN(__builtin_ia32_loadupd512_mask) \
VECTOR_INTRIN(__builtin_ia32_loadups) \
VECTOR_INTRIN(__builtin_ia32_loadups128_mask) \
VECTOR_INTRIN(__builtin_ia32_loadups256) \
VECTOR_INTRIN(__builtin_ia32_loadups256_mask) \
VECTOR_INTRIN(__builtin_ia32_loadups512_mask) \
VECTOR_INTRIN(__builtin_ia32_lwpins32) \
VECTOR_INTRIN(__builtin_ia32_lwpins64) \
VECTOR_INTRIN(__builtin_ia32_lwpval32) \
VECTOR_INTRIN(__builtin_ia32_lwpval64) \
VECTOR_INTRIN(__builtin_ia32_lzcnt_u16) \
VECTOR_INTRIN(__builtin_ia32_lzcnt_u32) \
VECTOR_INTRIN(__builtin_ia32_lzcnt_u64) \
VECTOR_INTRIN(__builtin_ia32_maskloadd) \
VECTOR_INTRIN(__builtin_ia32_maskloadd256) \
VECTOR_INTRIN(__builtin_ia32_maskloadpd) \
VECTOR_INTRIN(__builtin_ia32_maskloadpd256) \
VECTOR_INTRIN(__builtin_ia32_maskloadps) \
VECTOR_INTRIN(__builtin_ia32_maskloadps256) \
VECTOR_INTRIN(__builtin_ia32_maskloadq) \
VECTOR_INTRIN(__builtin_ia32_maskloadq256) \
VECTOR_INTRIN(__builtin_ia32_maskmovdqu) \
VECTOR_INTRIN(__builtin_ia32_maskmovq) \
VECTOR_INTRIN(__builtin_ia32_maskstored) \
VECTOR_INTRIN(__builtin_ia32_maskstored256) \
VECTOR_INTRIN(__builtin_ia32_maskstorepd) \
VECTOR_INTRIN(__builtin_ia32_maskstorepd256) \
VECTOR_INTRIN(__builtin_ia32_maskstoreps) \
VECTOR_INTRIN(__builtin_ia32_maskstoreps256) \
VECTOR_INTRIN(__builtin_ia32_maskstoreq) \
VECTOR_INTRIN(__builtin_ia32_maskstoreq256) \
VECTOR_INTRIN(__builtin_ia32_maxpd) \
VECTOR_INTRIN(__builtin_ia32_maxpd256) \
VECTOR_INTRIN(__builtin_ia32_maxpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_maxpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_maxpd_mask) \
VECTOR_INTRIN(__builtin_ia32_maxps) \
VECTOR_INTRIN(__builtin_ia32_maxps256) \
VECTOR_INTRIN(__builtin_ia32_maxps256_mask) \
VECTOR_INTRIN(__builtin_ia32_maxps512_mask) \
VECTOR_INTRIN(__builtin_ia32_maxps_mask) \
VECTOR_INTRIN(__builtin_ia32_maxsd) \
VECTOR_INTRIN(__builtin_ia32_maxsd_round) \
VECTOR_INTRIN(__builtin_ia32_maxss) \
VECTOR_INTRIN(__builtin_ia32_maxss_round) \
VECTOR_INTRIN(__builtin_ia32_mfence) \
VECTOR_INTRIN(__builtin_ia32_minpd) \
VECTOR_INTRIN(__builtin_ia32_minpd256) \
VECTOR_INTRIN(__builtin_ia32_minpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_minpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_minpd_mask) \
VECTOR_INTRIN(__builtin_ia32_minps) \
VECTOR_INTRIN(__builtin_ia32_minps256) \
VECTOR_INTRIN(__builtin_ia32_minps256_mask) \
VECTOR_INTRIN(__builtin_ia32_minps512_mask) \
VECTOR_INTRIN(__builtin_ia32_minps_mask) \
VECTOR_INTRIN(__builtin_ia32_minsd) \
VECTOR_INTRIN(__builtin_ia32_minsd_round) \
VECTOR_INTRIN(__builtin_ia32_minss) \
VECTOR_INTRIN(__builtin_ia32_minss_round) \
VECTOR_INTRIN(__builtin_ia32_monitor) \
VECTOR_INTRIN(__builtin_ia32_monitorx) \
VECTOR_INTRIN(__builtin_ia32_movapd128_mask) \
VECTOR_INTRIN(__builtin_ia32_movapd256_mask) \
VECTOR_INTRIN(__builtin_ia32_movapd512_mask) \
VECTOR_INTRIN(__builtin_ia32_movaps128_mask) \
VECTOR_INTRIN(__builtin_ia32_movaps256_mask) \
VECTOR_INTRIN(__builtin_ia32_movaps512_mask) \
VECTOR_INTRIN(__builtin_ia32_movddup128_mask) \
VECTOR_INTRIN(__builtin_ia32_movddup256) \
VECTOR_INTRIN(__builtin_ia32_movddup256_mask) \
VECTOR_INTRIN(__builtin_ia32_movddup512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32_128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32_256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32_512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32load128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32load256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32load512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32store128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32store256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa32store512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64_128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64_256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64_512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64load128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64load256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64load512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64store128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64store256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdqa64store512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdquhi128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdquhi256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdquhi512_mask) \
VECTOR_INTRIN(__builtin_ia32_movdquqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_movdquqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_movdquqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_movhlps) \
VECTOR_INTRIN(__builtin_ia32_movlhps) \
VECTOR_INTRIN(__builtin_ia32_movmskpd) \
VECTOR_INTRIN(__builtin_ia32_movmskpd256) \
VECTOR_INTRIN(__builtin_ia32_movmskps) \
VECTOR_INTRIN(__builtin_ia32_movmskps256) \
VECTOR_INTRIN(__builtin_ia32_movntdq) \
VECTOR_INTRIN(__builtin_ia32_movntdq256) \
VECTOR_INTRIN(__builtin_ia32_movntdq512) \
VECTOR_INTRIN(__builtin_ia32_movntdqa) \
VECTOR_INTRIN(__builtin_ia32_movntdqa256) \
VECTOR_INTRIN(__builtin_ia32_movntdqa512) \
VECTOR_INTRIN(__builtin_ia32_movnti) \
VECTOR_INTRIN(__builtin_ia32_movnti64) \
VECTOR_INTRIN(__builtin_ia32_movntpd) \
VECTOR_INTRIN(__builtin_ia32_movntpd256) \
VECTOR_INTRIN(__builtin_ia32_movntpd512) \
VECTOR_INTRIN(__builtin_ia32_movntps) \
VECTOR_INTRIN(__builtin_ia32_movntps256) \
VECTOR_INTRIN(__builtin_ia32_movntps512) \
VECTOR_INTRIN(__builtin_ia32_movntq) \
VECTOR_INTRIN(__builtin_ia32_movntsd) \
VECTOR_INTRIN(__builtin_ia32_movntss) \
VECTOR_INTRIN(__builtin_ia32_movq128) \
VECTOR_INTRIN(__builtin_ia32_movsd) \
VECTOR_INTRIN(__builtin_ia32_movshdup) \
VECTOR_INTRIN(__builtin_ia32_movshdup128_mask) \
VECTOR_INTRIN(__builtin_ia32_movshdup256) \
VECTOR_INTRIN(__builtin_ia32_movshdup256_mask) \
VECTOR_INTRIN(__builtin_ia32_movshdup512_mask) \
VECTOR_INTRIN(__builtin_ia32_movsldup) \
VECTOR_INTRIN(__builtin_ia32_movsldup128_mask) \
VECTOR_INTRIN(__builtin_ia32_movsldup256) \
VECTOR_INTRIN(__builtin_ia32_movsldup256_mask) \
VECTOR_INTRIN(__builtin_ia32_movsldup512_mask) \
VECTOR_INTRIN(__builtin_ia32_movss) \
VECTOR_INTRIN(__builtin_ia32_mpsadbw128) \
VECTOR_INTRIN(__builtin_ia32_mpsadbw256) \
VECTOR_INTRIN(__builtin_ia32_mulpd) \
VECTOR_INTRIN(__builtin_ia32_mulpd256) \
VECTOR_INTRIN(__builtin_ia32_mulpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_mulpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_mulpd_mask) \
VECTOR_INTRIN(__builtin_ia32_mulps) \
VECTOR_INTRIN(__builtin_ia32_mulps256) \
VECTOR_INTRIN(__builtin_ia32_mulps256_mask) \
VECTOR_INTRIN(__builtin_ia32_mulps512_mask) \
VECTOR_INTRIN(__builtin_ia32_mulps_mask) \
VECTOR_INTRIN(__builtin_ia32_mulsd) \
VECTOR_INTRIN(__builtin_ia32_mulsd_round) \
VECTOR_INTRIN(__builtin_ia32_mulss) \
VECTOR_INTRIN(__builtin_ia32_mulss_round) \
VECTOR_INTRIN(__builtin_ia32_mwait) \
VECTOR_INTRIN(__builtin_ia32_mwaitx) \
VECTOR_INTRIN(__builtin_ia32_orpd) \
VECTOR_INTRIN(__builtin_ia32_orpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_orpd256) \
VECTOR_INTRIN(__builtin_ia32_orpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_orpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_orps) \
VECTOR_INTRIN(__builtin_ia32_orps128_mask) \
VECTOR_INTRIN(__builtin_ia32_orps256) \
VECTOR_INTRIN(__builtin_ia32_orps256_mask) \
VECTOR_INTRIN(__builtin_ia32_orps512_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsb) \
VECTOR_INTRIN(__builtin_ia32_pabsb128) \
VECTOR_INTRIN(__builtin_ia32_pabsb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsb256) \
VECTOR_INTRIN(__builtin_ia32_pabsb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsd) \
VECTOR_INTRIN(__builtin_ia32_pabsd128) \
VECTOR_INTRIN(__builtin_ia32_pabsd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsd256) \
VECTOR_INTRIN(__builtin_ia32_pabsd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsw) \
VECTOR_INTRIN(__builtin_ia32_pabsw128) \
VECTOR_INTRIN(__builtin_ia32_pabsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsw256) \
VECTOR_INTRIN(__builtin_ia32_pabsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pabsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_packssdw) \
VECTOR_INTRIN(__builtin_ia32_packssdw128) \
VECTOR_INTRIN(__builtin_ia32_packssdw128_mask) \
VECTOR_INTRIN(__builtin_ia32_packssdw256) \
VECTOR_INTRIN(__builtin_ia32_packssdw256_mask) \
VECTOR_INTRIN(__builtin_ia32_packssdw512_mask) \
VECTOR_INTRIN(__builtin_ia32_packsswb) \
VECTOR_INTRIN(__builtin_ia32_packsswb128) \
VECTOR_INTRIN(__builtin_ia32_packsswb128_mask) \
VECTOR_INTRIN(__builtin_ia32_packsswb256) \
VECTOR_INTRIN(__builtin_ia32_packsswb256_mask) \
VECTOR_INTRIN(__builtin_ia32_packsswb512_mask) \
VECTOR_INTRIN(__builtin_ia32_packusdw128) \
VECTOR_INTRIN(__builtin_ia32_packusdw128_mask) \
VECTOR_INTRIN(__builtin_ia32_packusdw256) \
VECTOR_INTRIN(__builtin_ia32_packusdw256_mask) \
VECTOR_INTRIN(__builtin_ia32_packusdw512_mask) \
VECTOR_INTRIN(__builtin_ia32_packuswb) \
VECTOR_INTRIN(__builtin_ia32_packuswb128) \
VECTOR_INTRIN(__builtin_ia32_packuswb128_mask) \
VECTOR_INTRIN(__builtin_ia32_packuswb256) \
VECTOR_INTRIN(__builtin_ia32_packuswb256_mask) \
VECTOR_INTRIN(__builtin_ia32_packuswb512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddb) \
VECTOR_INTRIN(__builtin_ia32_paddb128) \
VECTOR_INTRIN(__builtin_ia32_paddb128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddb256) \
VECTOR_INTRIN(__builtin_ia32_paddb256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddb512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddd) \
VECTOR_INTRIN(__builtin_ia32_paddd128) \
VECTOR_INTRIN(__builtin_ia32_paddd128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddd256) \
VECTOR_INTRIN(__builtin_ia32_paddd256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddd512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddq) \
VECTOR_INTRIN(__builtin_ia32_paddq128) \
VECTOR_INTRIN(__builtin_ia32_paddq128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddq256) \
VECTOR_INTRIN(__builtin_ia32_paddq256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddq512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddsb) \
VECTOR_INTRIN(__builtin_ia32_paddsb128) \
VECTOR_INTRIN(__builtin_ia32_paddsb128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddsb256) \
VECTOR_INTRIN(__builtin_ia32_paddsb256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddsb512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddsw) \
VECTOR_INTRIN(__builtin_ia32_paddsw128) \
VECTOR_INTRIN(__builtin_ia32_paddsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddsw256) \
VECTOR_INTRIN(__builtin_ia32_paddsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddusb) \
VECTOR_INTRIN(__builtin_ia32_paddusb128) \
VECTOR_INTRIN(__builtin_ia32_paddusb128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddusb256) \
VECTOR_INTRIN(__builtin_ia32_paddusb256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddusb512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddusw) \
VECTOR_INTRIN(__builtin_ia32_paddusw128) \
VECTOR_INTRIN(__builtin_ia32_paddusw128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddusw256) \
VECTOR_INTRIN(__builtin_ia32_paddusw256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddusw512_mask) \
VECTOR_INTRIN(__builtin_ia32_paddw) \
VECTOR_INTRIN(__builtin_ia32_paddw128) \
VECTOR_INTRIN(__builtin_ia32_paddw128_mask) \
VECTOR_INTRIN(__builtin_ia32_paddw256) \
VECTOR_INTRIN(__builtin_ia32_paddw256_mask) \
VECTOR_INTRIN(__builtin_ia32_paddw512_mask) \
VECTOR_INTRIN(__builtin_ia32_palignr) \
VECTOR_INTRIN(__builtin_ia32_palignr128) \
VECTOR_INTRIN(__builtin_ia32_palignr128_mask) \
VECTOR_INTRIN(__builtin_ia32_palignr256) \
VECTOR_INTRIN(__builtin_ia32_palignr256_mask) \
VECTOR_INTRIN(__builtin_ia32_palignr512) \
VECTOR_INTRIN(__builtin_ia32_palignr512_mask) \
VECTOR_INTRIN(__builtin_ia32_pand) \
VECTOR_INTRIN(__builtin_ia32_pand128) \
VECTOR_INTRIN(__builtin_ia32_pandd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pandd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pandd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pandn) \
VECTOR_INTRIN(__builtin_ia32_pandn128) \
VECTOR_INTRIN(__builtin_ia32_pandnd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pandnd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pandnd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pandnq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pandnq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pandnq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pandq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pandq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pandq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pause) \
VECTOR_INTRIN(__builtin_ia32_pavgb) \
VECTOR_INTRIN(__builtin_ia32_pavgb128) \
VECTOR_INTRIN(__builtin_ia32_pavgb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pavgb256) \
VECTOR_INTRIN(__builtin_ia32_pavgb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pavgb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pavgusb) \
VECTOR_INTRIN(__builtin_ia32_pavgw) \
VECTOR_INTRIN(__builtin_ia32_pavgw128) \
VECTOR_INTRIN(__builtin_ia32_pavgw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pavgw256) \
VECTOR_INTRIN(__builtin_ia32_pavgw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pavgw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pblendd128) \
VECTOR_INTRIN(__builtin_ia32_pblendd256) \
VECTOR_INTRIN(__builtin_ia32_pblendvb128) \
VECTOR_INTRIN(__builtin_ia32_pblendvb256) \
VECTOR_INTRIN(__builtin_ia32_pblendw128) \
VECTOR_INTRIN(__builtin_ia32_pblendw256) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb128) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb128_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb256) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb256_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb512_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd128) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd128_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd256) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd256_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd512) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastd512_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq128) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq128_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq256) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq256_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq512) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastq512_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw128) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw128_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw256) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw256_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw512_gpr_mask) \
VECTOR_INTRIN(__builtin_ia32_pbroadcastw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pclmulqdq128) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqb) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqb128) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqb256) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqd) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqd128) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqd256) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqq) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqq256) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqw) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqw128) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqw256) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpeqw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpestri128) \
VECTOR_INTRIN(__builtin_ia32_pcmpestria128) \
VECTOR_INTRIN(__builtin_ia32_pcmpestric128) \
VECTOR_INTRIN(__builtin_ia32_pcmpestrio128) \
VECTOR_INTRIN(__builtin_ia32_pcmpestris128) \
VECTOR_INTRIN(__builtin_ia32_pcmpestriz128) \
VECTOR_INTRIN(__builtin_ia32_pcmpestrm128) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtb) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtb128) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtb256) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtd) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtd128) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtd256) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtq) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtq256) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtw) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtw128) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtw256) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpgtw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pcmpistri128) \
VECTOR_INTRIN(__builtin_ia32_pcmpistria128) \
VECTOR_INTRIN(__builtin_ia32_pcmpistric128) \
VECTOR_INTRIN(__builtin_ia32_pcmpistrio128) \
VECTOR_INTRIN(__builtin_ia32_pcmpistris128) \
VECTOR_INTRIN(__builtin_ia32_pcmpistriz128) \
VECTOR_INTRIN(__builtin_ia32_pcmpistrm128) \
VECTOR_INTRIN(__builtin_ia32_pd256_pd) \
VECTOR_INTRIN(__builtin_ia32_pd512_256pd) \
VECTOR_INTRIN(__builtin_ia32_pd512_pd) \
VECTOR_INTRIN(__builtin_ia32_pd_pd256) \
VECTOR_INTRIN(__builtin_ia32_pdep_di) \
VECTOR_INTRIN(__builtin_ia32_pdep_si) \
VECTOR_INTRIN(__builtin_ia32_permdf256) \
VECTOR_INTRIN(__builtin_ia32_permdf256_mask) \
VECTOR_INTRIN(__builtin_ia32_permdf512_mask) \
VECTOR_INTRIN(__builtin_ia32_permdi256) \
VECTOR_INTRIN(__builtin_ia32_permdi256_mask) \
VECTOR_INTRIN(__builtin_ia32_permdi512_mask) \
VECTOR_INTRIN(__builtin_ia32_permti256) \
VECTOR_INTRIN(__builtin_ia32_permvardf256_mask) \
VECTOR_INTRIN(__builtin_ia32_permvardf512_mask) \
VECTOR_INTRIN(__builtin_ia32_permvardi256_mask) \
VECTOR_INTRIN(__builtin_ia32_permvardi512_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarhi128_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarhi256_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarhi512_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarsf256) \
VECTOR_INTRIN(__builtin_ia32_permvarsf256_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarsf512_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarsi256) \
VECTOR_INTRIN(__builtin_ia32_permvarsi256_mask) \
VECTOR_INTRIN(__builtin_ia32_permvarsi512_mask) \
VECTOR_INTRIN(__builtin_ia32_pext_di) \
VECTOR_INTRIN(__builtin_ia32_pext_si) \
VECTOR_INTRIN(__builtin_ia32_pf2id) \
VECTOR_INTRIN(__builtin_ia32_pfacc) \
VECTOR_INTRIN(__builtin_ia32_pfadd) \
VECTOR_INTRIN(__builtin_ia32_pfcmpeq) \
VECTOR_INTRIN(__builtin_ia32_pfcmpge) \
VECTOR_INTRIN(__builtin_ia32_pfcmpgt) \
VECTOR_INTRIN(__builtin_ia32_pfmax) \
VECTOR_INTRIN(__builtin_ia32_pfmin) \
VECTOR_INTRIN(__builtin_ia32_pfmul) \
VECTOR_INTRIN(__builtin_ia32_pfrcp) \
VECTOR_INTRIN(__builtin_ia32_pfrcpit1) \
VECTOR_INTRIN(__builtin_ia32_pfrcpit2) \
VECTOR_INTRIN(__builtin_ia32_pfrsqit1) \
VECTOR_INTRIN(__builtin_ia32_pfrsqrt) \
VECTOR_INTRIN(__builtin_ia32_pfsub) \
VECTOR_INTRIN(__builtin_ia32_pfsubr) \
VECTOR_INTRIN(__builtin_ia32_phaddd) \
VECTOR_INTRIN(__builtin_ia32_phaddd128) \
VECTOR_INTRIN(__builtin_ia32_phaddd256) \
VECTOR_INTRIN(__builtin_ia32_phaddsw) \
VECTOR_INTRIN(__builtin_ia32_phaddsw128) \
VECTOR_INTRIN(__builtin_ia32_phaddsw256) \
VECTOR_INTRIN(__builtin_ia32_phaddw) \
VECTOR_INTRIN(__builtin_ia32_phaddw128) \
VECTOR_INTRIN(__builtin_ia32_phaddw256) \
VECTOR_INTRIN(__builtin_ia32_phminposuw128) \
VECTOR_INTRIN(__builtin_ia32_phsubd) \
VECTOR_INTRIN(__builtin_ia32_phsubd128) \
VECTOR_INTRIN(__builtin_ia32_phsubd256) \
VECTOR_INTRIN(__builtin_ia32_phsubsw) \
VECTOR_INTRIN(__builtin_ia32_phsubsw128) \
VECTOR_INTRIN(__builtin_ia32_phsubsw256) \
VECTOR_INTRIN(__builtin_ia32_phsubw) \
VECTOR_INTRIN(__builtin_ia32_phsubw128) \
VECTOR_INTRIN(__builtin_ia32_phsubw256) \
VECTOR_INTRIN(__builtin_ia32_pi2fd) \
VECTOR_INTRIN(__builtin_ia32_pmaddubsw) \
VECTOR_INTRIN(__builtin_ia32_pmaddubsw128) \
VECTOR_INTRIN(__builtin_ia32_pmaddubsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaddubsw256) \
VECTOR_INTRIN(__builtin_ia32_pmaddubsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaddubsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaddwd) \
VECTOR_INTRIN(__builtin_ia32_pmaddwd128) \
VECTOR_INTRIN(__builtin_ia32_pmaddwd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaddwd256) \
VECTOR_INTRIN(__builtin_ia32_pmaddwd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaddwd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsb128) \
VECTOR_INTRIN(__builtin_ia32_pmaxsb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsb256) \
VECTOR_INTRIN(__builtin_ia32_pmaxsb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsd128) \
VECTOR_INTRIN(__builtin_ia32_pmaxsd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsd256) \
VECTOR_INTRIN(__builtin_ia32_pmaxsd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsw) \
VECTOR_INTRIN(__builtin_ia32_pmaxsw128) \
VECTOR_INTRIN(__builtin_ia32_pmaxsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsw256) \
VECTOR_INTRIN(__builtin_ia32_pmaxsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxub) \
VECTOR_INTRIN(__builtin_ia32_pmaxub128) \
VECTOR_INTRIN(__builtin_ia32_pmaxub128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxub256) \
VECTOR_INTRIN(__builtin_ia32_pmaxub256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxub512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxud128) \
VECTOR_INTRIN(__builtin_ia32_pmaxud128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxud256) \
VECTOR_INTRIN(__builtin_ia32_pmaxud256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxud512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxuq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxuq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxuq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxuw128) \
VECTOR_INTRIN(__builtin_ia32_pmaxuw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxuw256) \
VECTOR_INTRIN(__builtin_ia32_pmaxuw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmaxuw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsb128) \
VECTOR_INTRIN(__builtin_ia32_pminsb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsb256) \
VECTOR_INTRIN(__builtin_ia32_pminsb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsd128) \
VECTOR_INTRIN(__builtin_ia32_pminsd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsd256) \
VECTOR_INTRIN(__builtin_ia32_pminsd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsw) \
VECTOR_INTRIN(__builtin_ia32_pminsw128) \
VECTOR_INTRIN(__builtin_ia32_pminsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsw256) \
VECTOR_INTRIN(__builtin_ia32_pminsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminub) \
VECTOR_INTRIN(__builtin_ia32_pminub128) \
VECTOR_INTRIN(__builtin_ia32_pminub128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminub256) \
VECTOR_INTRIN(__builtin_ia32_pminub256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminub512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminud128) \
VECTOR_INTRIN(__builtin_ia32_pminud128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminud256) \
VECTOR_INTRIN(__builtin_ia32_pminud256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminud512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminuq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminuq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminuq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pminuw128) \
VECTOR_INTRIN(__builtin_ia32_pminuw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pminuw256) \
VECTOR_INTRIN(__builtin_ia32_pminuw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pminuw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdb128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdb256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdb512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdw128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdw256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovdw512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovmskb) \
VECTOR_INTRIN(__builtin_ia32_pmovmskb128) \
VECTOR_INTRIN(__builtin_ia32_pmovmskb256) \
VECTOR_INTRIN(__builtin_ia32_pmovqb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqb128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqb256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqb512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqd128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqd256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqd512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqw128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqw256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovqw512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdb128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdb256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdb512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdw128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdw256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsdw512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqb128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqb256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqb512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqd128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqd256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqd512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqw128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqw256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsqw512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovswb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovswb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovswb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbd128) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbd256) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbq128) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbq256) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbw128) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbw256) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxbw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxdq128) \
VECTOR_INTRIN(__builtin_ia32_pmovsxdq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxdq256) \
VECTOR_INTRIN(__builtin_ia32_pmovsxdq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxdq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwd128) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwd256) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwq128) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwq256) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovsxwq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdb128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdb256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdb512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdw128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdw256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusdw512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqb128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqb256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqb512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqd128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqd256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqd512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqw128mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqw256mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovusqw512mem_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovuswb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovuswb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovuswb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovwb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovwb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovwb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbd128) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbd256) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbq128) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbq256) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbw128) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbw256) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxbw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxdq128) \
VECTOR_INTRIN(__builtin_ia32_pmovzxdq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxdq256) \
VECTOR_INTRIN(__builtin_ia32_pmovzxdq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxdq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwd128) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwd256) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwq128) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwq256) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmovzxwq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmuldq128) \
VECTOR_INTRIN(__builtin_ia32_pmuldq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmuldq256) \
VECTOR_INTRIN(__builtin_ia32_pmuldq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmuldq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhrsw) \
VECTOR_INTRIN(__builtin_ia32_pmulhrsw128) \
VECTOR_INTRIN(__builtin_ia32_pmulhrsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhrsw256) \
VECTOR_INTRIN(__builtin_ia32_pmulhrsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhrsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhrw) \
VECTOR_INTRIN(__builtin_ia32_pmulhuw) \
VECTOR_INTRIN(__builtin_ia32_pmulhuw128) \
VECTOR_INTRIN(__builtin_ia32_pmulhuw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhuw256) \
VECTOR_INTRIN(__builtin_ia32_pmulhuw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhuw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhw) \
VECTOR_INTRIN(__builtin_ia32_pmulhw128) \
VECTOR_INTRIN(__builtin_ia32_pmulhw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhw256) \
VECTOR_INTRIN(__builtin_ia32_pmulhw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulhw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulld128) \
VECTOR_INTRIN(__builtin_ia32_pmulld128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulld256) \
VECTOR_INTRIN(__builtin_ia32_pmulld256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmulld512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmullq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmullq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmullq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmullw) \
VECTOR_INTRIN(__builtin_ia32_pmullw128) \
VECTOR_INTRIN(__builtin_ia32_pmullw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmullw256) \
VECTOR_INTRIN(__builtin_ia32_pmullw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmullw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pmuludq) \
VECTOR_INTRIN(__builtin_ia32_pmuludq128) \
VECTOR_INTRIN(__builtin_ia32_pmuludq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pmuludq256) \
VECTOR_INTRIN(__builtin_ia32_pmuludq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pmuludq512_mask) \
VECTOR_INTRIN(__builtin_ia32_por) \
VECTOR_INTRIN(__builtin_ia32_por128) \
VECTOR_INTRIN(__builtin_ia32_por256) \
VECTOR_INTRIN(__builtin_ia32_pord128_mask) \
VECTOR_INTRIN(__builtin_ia32_pord256_mask) \
VECTOR_INTRIN(__builtin_ia32_pord512_mask) \
VECTOR_INTRIN(__builtin_ia32_porq128_mask) \
VECTOR_INTRIN(__builtin_ia32_porq256_mask) \
VECTOR_INTRIN(__builtin_ia32_porq512_mask) \
VECTOR_INTRIN(__builtin_ia32_prold128_mask) \
VECTOR_INTRIN(__builtin_ia32_prold256_mask) \
VECTOR_INTRIN(__builtin_ia32_prold512_mask) \
VECTOR_INTRIN(__builtin_ia32_prolq128_mask) \
VECTOR_INTRIN(__builtin_ia32_prolq256_mask) \
VECTOR_INTRIN(__builtin_ia32_prolq512_mask) \
VECTOR_INTRIN(__builtin_ia32_prolvd128_mask) \
VECTOR_INTRIN(__builtin_ia32_prolvd256_mask) \
VECTOR_INTRIN(__builtin_ia32_prolvd512_mask) \
VECTOR_INTRIN(__builtin_ia32_prolvq128_mask) \
VECTOR_INTRIN(__builtin_ia32_prolvq256_mask) \
VECTOR_INTRIN(__builtin_ia32_prolvq512_mask) \
VECTOR_INTRIN(__builtin_ia32_prord128_mask) \
VECTOR_INTRIN(__builtin_ia32_prord256_mask) \
VECTOR_INTRIN(__builtin_ia32_prord512_mask) \
VECTOR_INTRIN(__builtin_ia32_prorq128_mask) \
VECTOR_INTRIN(__builtin_ia32_prorq256_mask) \
VECTOR_INTRIN(__builtin_ia32_prorq512_mask) \
VECTOR_INTRIN(__builtin_ia32_prorvd128_mask) \
VECTOR_INTRIN(__builtin_ia32_prorvd256_mask) \
VECTOR_INTRIN(__builtin_ia32_prorvd512_mask) \
VECTOR_INTRIN(__builtin_ia32_prorvq128_mask) \
VECTOR_INTRIN(__builtin_ia32_prorvq256_mask) \
VECTOR_INTRIN(__builtin_ia32_prorvq512_mask) \
VECTOR_INTRIN(__builtin_ia32_ps256_ps) \
VECTOR_INTRIN(__builtin_ia32_ps512_256ps) \
VECTOR_INTRIN(__builtin_ia32_ps512_ps) \
VECTOR_INTRIN(__builtin_ia32_ps_ps256) \
VECTOR_INTRIN(__builtin_ia32_psadbw) \
VECTOR_INTRIN(__builtin_ia32_psadbw128) \
VECTOR_INTRIN(__builtin_ia32_psadbw256) \
VECTOR_INTRIN(__builtin_ia32_psadbw512) \
VECTOR_INTRIN(__builtin_ia32_pshufb) \
VECTOR_INTRIN(__builtin_ia32_pshufb128) \
VECTOR_INTRIN(__builtin_ia32_pshufb128_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufb256) \
VECTOR_INTRIN(__builtin_ia32_pshufb256_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufb512_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufd) \
VECTOR_INTRIN(__builtin_ia32_pshufd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufd256) \
VECTOR_INTRIN(__builtin_ia32_pshufd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufhw) \
VECTOR_INTRIN(__builtin_ia32_pshufhw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufhw256) \
VECTOR_INTRIN(__builtin_ia32_pshufhw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufhw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pshuflw) \
VECTOR_INTRIN(__builtin_ia32_pshuflw128_mask) \
VECTOR_INTRIN(__builtin_ia32_pshuflw256) \
VECTOR_INTRIN(__builtin_ia32_pshuflw256_mask) \
VECTOR_INTRIN(__builtin_ia32_pshuflw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pshufw) \
VECTOR_INTRIN(__builtin_ia32_psignb) \
VECTOR_INTRIN(__builtin_ia32_psignb128) \
VECTOR_INTRIN(__builtin_ia32_psignb256) \
VECTOR_INTRIN(__builtin_ia32_psignd) \
VECTOR_INTRIN(__builtin_ia32_psignd128) \
VECTOR_INTRIN(__builtin_ia32_psignd256) \
VECTOR_INTRIN(__builtin_ia32_psignw) \
VECTOR_INTRIN(__builtin_ia32_psignw128) \
VECTOR_INTRIN(__builtin_ia32_psignw256) \
VECTOR_INTRIN(__builtin_ia32_pslld) \
VECTOR_INTRIN(__builtin_ia32_pslld128) \
VECTOR_INTRIN(__builtin_ia32_pslld128_mask) \
VECTOR_INTRIN(__builtin_ia32_pslld256) \
VECTOR_INTRIN(__builtin_ia32_pslld256_mask) \
VECTOR_INTRIN(__builtin_ia32_pslld512_mask) \
VECTOR_INTRIN(__builtin_ia32_pslldi) \
VECTOR_INTRIN(__builtin_ia32_pslldi128) \
VECTOR_INTRIN(__builtin_ia32_pslldi128_mask) \
VECTOR_INTRIN(__builtin_ia32_pslldi256) \
VECTOR_INTRIN(__builtin_ia32_pslldi256_mask) \
VECTOR_INTRIN(__builtin_ia32_pslldi512_mask) \
VECTOR_INTRIN(__builtin_ia32_pslldq512) \
VECTOR_INTRIN(__builtin_ia32_pslldqi128) \
VECTOR_INTRIN(__builtin_ia32_pslldqi256) \
VECTOR_INTRIN(__builtin_ia32_psllq) \
VECTOR_INTRIN(__builtin_ia32_psllq128) \
VECTOR_INTRIN(__builtin_ia32_psllq128_mask) \
VECTOR_INTRIN(__builtin_ia32_psllq256) \
VECTOR_INTRIN(__builtin_ia32_psllq256_mask) \
VECTOR_INTRIN(__builtin_ia32_psllq512_mask) \
VECTOR_INTRIN(__builtin_ia32_psllqi) \
VECTOR_INTRIN(__builtin_ia32_psllqi128) \
VECTOR_INTRIN(__builtin_ia32_psllqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psllqi256) \
VECTOR_INTRIN(__builtin_ia32_psllqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psllqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv16hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv16si_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv2di) \
VECTOR_INTRIN(__builtin_ia32_psllv2di_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv32hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv4di) \
VECTOR_INTRIN(__builtin_ia32_psllv4di_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv4si) \
VECTOR_INTRIN(__builtin_ia32_psllv4si_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv8di_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv8hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psllv8si) \
VECTOR_INTRIN(__builtin_ia32_psllv8si_mask) \
VECTOR_INTRIN(__builtin_ia32_psllw) \
VECTOR_INTRIN(__builtin_ia32_psllw128) \
VECTOR_INTRIN(__builtin_ia32_psllw128_mask) \
VECTOR_INTRIN(__builtin_ia32_psllw256) \
VECTOR_INTRIN(__builtin_ia32_psllw256_mask) \
VECTOR_INTRIN(__builtin_ia32_psllw512_mask) \
VECTOR_INTRIN(__builtin_ia32_psllwi) \
VECTOR_INTRIN(__builtin_ia32_psllwi128) \
VECTOR_INTRIN(__builtin_ia32_psllwi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psllwi256) \
VECTOR_INTRIN(__builtin_ia32_psllwi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psllwi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrad) \
VECTOR_INTRIN(__builtin_ia32_psrad128) \
VECTOR_INTRIN(__builtin_ia32_psrad128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrad256) \
VECTOR_INTRIN(__builtin_ia32_psrad256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrad512_mask) \
VECTOR_INTRIN(__builtin_ia32_psradi) \
VECTOR_INTRIN(__builtin_ia32_psradi128) \
VECTOR_INTRIN(__builtin_ia32_psradi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psradi256) \
VECTOR_INTRIN(__builtin_ia32_psradi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psradi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psraq128_mask) \
VECTOR_INTRIN(__builtin_ia32_psraq256_mask) \
VECTOR_INTRIN(__builtin_ia32_psraq512_mask) \
VECTOR_INTRIN(__builtin_ia32_psraqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psraqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psraqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav16hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav16si_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav32hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav4si) \
VECTOR_INTRIN(__builtin_ia32_psrav4si_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav8di_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav8hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psrav8si) \
VECTOR_INTRIN(__builtin_ia32_psrav8si_mask) \
VECTOR_INTRIN(__builtin_ia32_psravq128_mask) \
VECTOR_INTRIN(__builtin_ia32_psravq256_mask) \
VECTOR_INTRIN(__builtin_ia32_psraw) \
VECTOR_INTRIN(__builtin_ia32_psraw128) \
VECTOR_INTRIN(__builtin_ia32_psraw128_mask) \
VECTOR_INTRIN(__builtin_ia32_psraw256) \
VECTOR_INTRIN(__builtin_ia32_psraw256_mask) \
VECTOR_INTRIN(__builtin_ia32_psraw512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrawi) \
VECTOR_INTRIN(__builtin_ia32_psrawi128) \
VECTOR_INTRIN(__builtin_ia32_psrawi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrawi256) \
VECTOR_INTRIN(__builtin_ia32_psrawi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrawi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrld) \
VECTOR_INTRIN(__builtin_ia32_psrld128) \
VECTOR_INTRIN(__builtin_ia32_psrld128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrld256) \
VECTOR_INTRIN(__builtin_ia32_psrld256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrld512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrldi) \
VECTOR_INTRIN(__builtin_ia32_psrldi128) \
VECTOR_INTRIN(__builtin_ia32_psrldi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrldi256) \
VECTOR_INTRIN(__builtin_ia32_psrldi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrldi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrldq512) \
VECTOR_INTRIN(__builtin_ia32_psrldqi128) \
VECTOR_INTRIN(__builtin_ia32_psrldqi256) \
VECTOR_INTRIN(__builtin_ia32_psrlq) \
VECTOR_INTRIN(__builtin_ia32_psrlq128) \
VECTOR_INTRIN(__builtin_ia32_psrlq128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlq256) \
VECTOR_INTRIN(__builtin_ia32_psrlq256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlq512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlqi) \
VECTOR_INTRIN(__builtin_ia32_psrlqi128) \
VECTOR_INTRIN(__builtin_ia32_psrlqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlqi256) \
VECTOR_INTRIN(__builtin_ia32_psrlqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv16hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv16si_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv2di) \
VECTOR_INTRIN(__builtin_ia32_psrlv2di_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv32hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv4di) \
VECTOR_INTRIN(__builtin_ia32_psrlv4di_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv4si) \
VECTOR_INTRIN(__builtin_ia32_psrlv4si_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv8di_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv8hi_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlv8si) \
VECTOR_INTRIN(__builtin_ia32_psrlv8si_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlw) \
VECTOR_INTRIN(__builtin_ia32_psrlw128) \
VECTOR_INTRIN(__builtin_ia32_psrlw128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlw256) \
VECTOR_INTRIN(__builtin_ia32_psrlw256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlw512_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlwi) \
VECTOR_INTRIN(__builtin_ia32_psrlwi128) \
VECTOR_INTRIN(__builtin_ia32_psrlwi128_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlwi256) \
VECTOR_INTRIN(__builtin_ia32_psrlwi256_mask) \
VECTOR_INTRIN(__builtin_ia32_psrlwi512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubb) \
VECTOR_INTRIN(__builtin_ia32_psubb128) \
VECTOR_INTRIN(__builtin_ia32_psubb128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubb256) \
VECTOR_INTRIN(__builtin_ia32_psubb256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubb512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubd) \
VECTOR_INTRIN(__builtin_ia32_psubd128) \
VECTOR_INTRIN(__builtin_ia32_psubd128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubd256) \
VECTOR_INTRIN(__builtin_ia32_psubd256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubd512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubq) \
VECTOR_INTRIN(__builtin_ia32_psubq128) \
VECTOR_INTRIN(__builtin_ia32_psubq128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubq256) \
VECTOR_INTRIN(__builtin_ia32_psubq256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubq512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubsb) \
VECTOR_INTRIN(__builtin_ia32_psubsb128) \
VECTOR_INTRIN(__builtin_ia32_psubsb128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubsb256) \
VECTOR_INTRIN(__builtin_ia32_psubsb256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubsb512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubsw) \
VECTOR_INTRIN(__builtin_ia32_psubsw128) \
VECTOR_INTRIN(__builtin_ia32_psubsw128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubsw256) \
VECTOR_INTRIN(__builtin_ia32_psubsw256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubsw512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubusb) \
VECTOR_INTRIN(__builtin_ia32_psubusb128) \
VECTOR_INTRIN(__builtin_ia32_psubusb128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubusb256) \
VECTOR_INTRIN(__builtin_ia32_psubusb256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubusb512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubusw) \
VECTOR_INTRIN(__builtin_ia32_psubusw128) \
VECTOR_INTRIN(__builtin_ia32_psubusw128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubusw256) \
VECTOR_INTRIN(__builtin_ia32_psubusw256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubusw512_mask) \
VECTOR_INTRIN(__builtin_ia32_psubw) \
VECTOR_INTRIN(__builtin_ia32_psubw128) \
VECTOR_INTRIN(__builtin_ia32_psubw128_mask) \
VECTOR_INTRIN(__builtin_ia32_psubw256) \
VECTOR_INTRIN(__builtin_ia32_psubw256_mask) \
VECTOR_INTRIN(__builtin_ia32_psubw512_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogd128_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogd128_maskz) \
VECTOR_INTRIN(__builtin_ia32_pternlogd256_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogd256_maskz) \
VECTOR_INTRIN(__builtin_ia32_pternlogd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogd512_maskz) \
VECTOR_INTRIN(__builtin_ia32_pternlogq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogq128_maskz) \
VECTOR_INTRIN(__builtin_ia32_pternlogq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogq256_maskz) \
VECTOR_INTRIN(__builtin_ia32_pternlogq512_mask) \
VECTOR_INTRIN(__builtin_ia32_pternlogq512_maskz) \
VECTOR_INTRIN(__builtin_ia32_ptestc128) \
VECTOR_INTRIN(__builtin_ia32_ptestc256) \
VECTOR_INTRIN(__builtin_ia32_ptestmb128) \
VECTOR_INTRIN(__builtin_ia32_ptestmb256) \
VECTOR_INTRIN(__builtin_ia32_ptestmb512) \
VECTOR_INTRIN(__builtin_ia32_ptestmd128) \
VECTOR_INTRIN(__builtin_ia32_ptestmd256) \
VECTOR_INTRIN(__builtin_ia32_ptestmd512) \
VECTOR_INTRIN(__builtin_ia32_ptestmq128) \
VECTOR_INTRIN(__builtin_ia32_ptestmq256) \
VECTOR_INTRIN(__builtin_ia32_ptestmq512) \
VECTOR_INTRIN(__builtin_ia32_ptestmw128) \
VECTOR_INTRIN(__builtin_ia32_ptestmw256) \
VECTOR_INTRIN(__builtin_ia32_ptestmw512) \
VECTOR_INTRIN(__builtin_ia32_ptestnmb128) \
VECTOR_INTRIN(__builtin_ia32_ptestnmb256) \
VECTOR_INTRIN(__builtin_ia32_ptestnmb512) \
VECTOR_INTRIN(__builtin_ia32_ptestnmd128) \
VECTOR_INTRIN(__builtin_ia32_ptestnmd256) \
VECTOR_INTRIN(__builtin_ia32_ptestnmd512) \
VECTOR_INTRIN(__builtin_ia32_ptestnmq128) \
VECTOR_INTRIN(__builtin_ia32_ptestnmq256) \
VECTOR_INTRIN(__builtin_ia32_ptestnmq512) \
VECTOR_INTRIN(__builtin_ia32_ptestnmw128) \
VECTOR_INTRIN(__builtin_ia32_ptestnmw256) \
VECTOR_INTRIN(__builtin_ia32_ptestnmw512) \
VECTOR_INTRIN(__builtin_ia32_ptestnzc128) \
VECTOR_INTRIN(__builtin_ia32_ptestnzc256) \
VECTOR_INTRIN(__builtin_ia32_ptestz128) \
VECTOR_INTRIN(__builtin_ia32_ptestz256) \
VECTOR_INTRIN(__builtin_ia32_punpckhbw) \
VECTOR_INTRIN(__builtin_ia32_punpckhbw128) \
VECTOR_INTRIN(__builtin_ia32_punpckhbw128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhbw256) \
VECTOR_INTRIN(__builtin_ia32_punpckhbw256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhbw512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhdq) \
VECTOR_INTRIN(__builtin_ia32_punpckhdq128) \
VECTOR_INTRIN(__builtin_ia32_punpckhdq128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhdq256) \
VECTOR_INTRIN(__builtin_ia32_punpckhdq256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhdq512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhqdq128) \
VECTOR_INTRIN(__builtin_ia32_punpckhqdq128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhqdq256) \
VECTOR_INTRIN(__builtin_ia32_punpckhqdq256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhqdq512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhwd) \
VECTOR_INTRIN(__builtin_ia32_punpckhwd128) \
VECTOR_INTRIN(__builtin_ia32_punpckhwd128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhwd256) \
VECTOR_INTRIN(__builtin_ia32_punpckhwd256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckhwd512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklbw) \
VECTOR_INTRIN(__builtin_ia32_punpcklbw128) \
VECTOR_INTRIN(__builtin_ia32_punpcklbw128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklbw256) \
VECTOR_INTRIN(__builtin_ia32_punpcklbw256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklbw512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckldq) \
VECTOR_INTRIN(__builtin_ia32_punpckldq128) \
VECTOR_INTRIN(__builtin_ia32_punpckldq128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckldq256) \
VECTOR_INTRIN(__builtin_ia32_punpckldq256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpckldq512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklqdq128) \
VECTOR_INTRIN(__builtin_ia32_punpcklqdq128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklqdq256) \
VECTOR_INTRIN(__builtin_ia32_punpcklqdq256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklqdq512_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklwd) \
VECTOR_INTRIN(__builtin_ia32_punpcklwd128) \
VECTOR_INTRIN(__builtin_ia32_punpcklwd128_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklwd256) \
VECTOR_INTRIN(__builtin_ia32_punpcklwd256_mask) \
VECTOR_INTRIN(__builtin_ia32_punpcklwd512_mask) \
VECTOR_INTRIN(__builtin_ia32_pxor) \
VECTOR_INTRIN(__builtin_ia32_pxor128) \
VECTOR_INTRIN(__builtin_ia32_pxor256) \
VECTOR_INTRIN(__builtin_ia32_pxord128_mask) \
VECTOR_INTRIN(__builtin_ia32_pxord256_mask) \
VECTOR_INTRIN(__builtin_ia32_pxord512_mask) \
VECTOR_INTRIN(__builtin_ia32_pxorq128_mask) \
VECTOR_INTRIN(__builtin_ia32_pxorq256_mask) \
VECTOR_INTRIN(__builtin_ia32_pxorq512_mask) \
VECTOR_INTRIN(__builtin_ia32_rangepd128_mask) \
VECTOR_INTRIN(__builtin_ia32_rangepd256_mask) \
VECTOR_INTRIN(__builtin_ia32_rangepd512_mask) \
VECTOR_INTRIN(__builtin_ia32_rangeps128_mask) \
VECTOR_INTRIN(__builtin_ia32_rangeps256_mask) \
VECTOR_INTRIN(__builtin_ia32_rangeps512_mask) \
VECTOR_INTRIN(__builtin_ia32_rangesd128_round) \
VECTOR_INTRIN(__builtin_ia32_rangess128_round) \
VECTOR_INTRIN(__builtin_ia32_rcp14pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp14pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp14pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp14ps128_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp14ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp14ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp14sd) \
VECTOR_INTRIN(__builtin_ia32_rcp14ss) \
VECTOR_INTRIN(__builtin_ia32_rcp28pd_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp28ps_mask) \
VECTOR_INTRIN(__builtin_ia32_rcp28sd_round) \
VECTOR_INTRIN(__builtin_ia32_rcp28ss_round) \
VECTOR_INTRIN(__builtin_ia32_rcpps) \
VECTOR_INTRIN(__builtin_ia32_rcpps256) \
VECTOR_INTRIN(__builtin_ia32_rcpss) \
VECTOR_INTRIN(__builtin_ia32_rdfsbase32) \
VECTOR_INTRIN(__builtin_ia32_rdfsbase64) \
VECTOR_INTRIN(__builtin_ia32_rdgsbase32) \
VECTOR_INTRIN(__builtin_ia32_rdgsbase64) \
VECTOR_INTRIN(__builtin_ia32_rdpid) \
VECTOR_INTRIN(__builtin_ia32_rdpkru) \
VECTOR_INTRIN(__builtin_ia32_rdpmc) \
VECTOR_INTRIN(__builtin_ia32_rdrand16_step) \
VECTOR_INTRIN(__builtin_ia32_rdrand32_step) \
VECTOR_INTRIN(__builtin_ia32_rdrand64_step) \
VECTOR_INTRIN(__builtin_ia32_rdseed_di_step) \
VECTOR_INTRIN(__builtin_ia32_rdseed_hi_step) \
VECTOR_INTRIN(__builtin_ia32_rdseed_si_step) \
VECTOR_INTRIN(__builtin_ia32_rdtsc) \
VECTOR_INTRIN(__builtin_ia32_rdtscp) \
VECTOR_INTRIN(__builtin_ia32_readeflags_u64) \
VECTOR_INTRIN(__builtin_ia32_reducepd128_mask) \
VECTOR_INTRIN(__builtin_ia32_reducepd256_mask) \
VECTOR_INTRIN(__builtin_ia32_reducepd512_mask) \
VECTOR_INTRIN(__builtin_ia32_reduceps128_mask) \
VECTOR_INTRIN(__builtin_ia32_reduceps256_mask) \
VECTOR_INTRIN(__builtin_ia32_reduceps512_mask) \
VECTOR_INTRIN(__builtin_ia32_reducesd) \
VECTOR_INTRIN(__builtin_ia32_reducess) \
VECTOR_INTRIN(__builtin_ia32_rndscalepd_128_mask) \
VECTOR_INTRIN(__builtin_ia32_rndscalepd_256_mask) \
VECTOR_INTRIN(__builtin_ia32_rndscalepd_mask) \
VECTOR_INTRIN(__builtin_ia32_rndscaleps_128_mask) \
VECTOR_INTRIN(__builtin_ia32_rndscaleps_256_mask) \
VECTOR_INTRIN(__builtin_ia32_rndscaleps_mask) \
VECTOR_INTRIN(__builtin_ia32_rndscalesd_round) \
VECTOR_INTRIN(__builtin_ia32_rndscaless_round) \
VECTOR_INTRIN(__builtin_ia32_rolhi) \
VECTOR_INTRIN(__builtin_ia32_rolqi) \
VECTOR_INTRIN(__builtin_ia32_rorhi) \
VECTOR_INTRIN(__builtin_ia32_rorqi) \
VECTOR_INTRIN(__builtin_ia32_roundpd) \
VECTOR_INTRIN(__builtin_ia32_roundpd256) \
VECTOR_INTRIN(__builtin_ia32_roundps) \
VECTOR_INTRIN(__builtin_ia32_roundps256) \
VECTOR_INTRIN(__builtin_ia32_roundsd) \
VECTOR_INTRIN(__builtin_ia32_roundss) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14pd128_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14pd256_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14pd512_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14ps128_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14sd) \
VECTOR_INTRIN(__builtin_ia32_rsqrt14ss) \
VECTOR_INTRIN(__builtin_ia32_rsqrt28pd_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt28ps_mask) \
VECTOR_INTRIN(__builtin_ia32_rsqrt28sd_round) \
VECTOR_INTRIN(__builtin_ia32_rsqrt28ss_round) \
VECTOR_INTRIN(__builtin_ia32_rsqrtps) \
VECTOR_INTRIN(__builtin_ia32_rsqrtps256) \
VECTOR_INTRIN(__builtin_ia32_rsqrtps_nr256) \
VECTOR_INTRIN(__builtin_ia32_rsqrtss) \
VECTOR_INTRIN(__builtin_ia32_sbb_u32) \
VECTOR_INTRIN(__builtin_ia32_sbb_u64) \
VECTOR_INTRIN(__builtin_ia32_scalefpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_scalefpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_scalefpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_scalefps128_mask) \
VECTOR_INTRIN(__builtin_ia32_scalefps256_mask) \
VECTOR_INTRIN(__builtin_ia32_scalefps512_mask) \
VECTOR_INTRIN(__builtin_ia32_scalefsd_round) \
VECTOR_INTRIN(__builtin_ia32_scalefss_round) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv16sf) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv16si) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv2df) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv2di) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv4df) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv4di) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv4sf) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv4si) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv8df) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv8di) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv8sf) \
VECTOR_INTRIN(__builtin_ia32_scatterdiv8si) \
VECTOR_INTRIN(__builtin_ia32_scatterpfdpd) \
VECTOR_INTRIN(__builtin_ia32_scatterpfdps) \
VECTOR_INTRIN(__builtin_ia32_scatterpfqpd) \
VECTOR_INTRIN(__builtin_ia32_scatterpfqps) \
VECTOR_INTRIN(__builtin_ia32_scattersiv16sf) \
VECTOR_INTRIN(__builtin_ia32_scattersiv16si) \
VECTOR_INTRIN(__builtin_ia32_scattersiv2df) \
VECTOR_INTRIN(__builtin_ia32_scattersiv2di) \
VECTOR_INTRIN(__builtin_ia32_scattersiv4df) \
VECTOR_INTRIN(__builtin_ia32_scattersiv4di) \
VECTOR_INTRIN(__builtin_ia32_scattersiv4sf) \
VECTOR_INTRIN(__builtin_ia32_scattersiv4si) \
VECTOR_INTRIN(__builtin_ia32_scattersiv8df) \
VECTOR_INTRIN(__builtin_ia32_scattersiv8di) \
VECTOR_INTRIN(__builtin_ia32_scattersiv8sf) \
VECTOR_INTRIN(__builtin_ia32_scattersiv8si) \
VECTOR_INTRIN(__builtin_ia32_sfence) \
VECTOR_INTRIN(__builtin_ia32_sha1msg1) \
VECTOR_INTRIN(__builtin_ia32_sha1msg2) \
VECTOR_INTRIN(__builtin_ia32_sha1nexte) \
VECTOR_INTRIN(__builtin_ia32_sha1rnds4) \
VECTOR_INTRIN(__builtin_ia32_sha256msg1) \
VECTOR_INTRIN(__builtin_ia32_sha256msg2) \
VECTOR_INTRIN(__builtin_ia32_sha256rnds2) \
VECTOR_INTRIN(__builtin_ia32_shuf_f32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_f32x4_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_f64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_f64x2_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_i32x4_256_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_i32x4_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_i64x2_256_mask) \
VECTOR_INTRIN(__builtin_ia32_shuf_i64x2_mask) \
VECTOR_INTRIN(__builtin_ia32_shufpd) \
VECTOR_INTRIN(__builtin_ia32_shufpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_shufpd256) \
VECTOR_INTRIN(__builtin_ia32_shufpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_shufpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_shufps) \
VECTOR_INTRIN(__builtin_ia32_shufps128_mask) \
VECTOR_INTRIN(__builtin_ia32_shufps256) \
VECTOR_INTRIN(__builtin_ia32_shufps256_mask) \
VECTOR_INTRIN(__builtin_ia32_shufps512_mask) \
VECTOR_INTRIN(__builtin_ia32_si256_si) \
VECTOR_INTRIN(__builtin_ia32_si512_256si) \
VECTOR_INTRIN(__builtin_ia32_si512_si) \
VECTOR_INTRIN(__builtin_ia32_si_si256) \
VECTOR_INTRIN(__builtin_ia32_slwpcb) \
VECTOR_INTRIN(__builtin_ia32_sqrtpd) \
VECTOR_INTRIN(__builtin_ia32_sqrtpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_sqrtpd256) \
VECTOR_INTRIN(__builtin_ia32_sqrtpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_sqrtpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_sqrtps) \
VECTOR_INTRIN(__builtin_ia32_sqrtps128_mask) \
VECTOR_INTRIN(__builtin_ia32_sqrtps256) \
VECTOR_INTRIN(__builtin_ia32_sqrtps256_mask) \
VECTOR_INTRIN(__builtin_ia32_sqrtps512_mask) \
VECTOR_INTRIN(__builtin_ia32_sqrtps_nr256) \
VECTOR_INTRIN(__builtin_ia32_sqrtsd) \
VECTOR_INTRIN(__builtin_ia32_sqrtsd_round) \
VECTOR_INTRIN(__builtin_ia32_sqrtss) \
VECTOR_INTRIN(__builtin_ia32_sqrtss_round) \
VECTOR_INTRIN(__builtin_ia32_stmxcsr) \
VECTOR_INTRIN(__builtin_ia32_storeapd128_mask) \
VECTOR_INTRIN(__builtin_ia32_storeapd256_mask) \
VECTOR_INTRIN(__builtin_ia32_storeapd512_mask) \
VECTOR_INTRIN(__builtin_ia32_storeaps128_mask) \
VECTOR_INTRIN(__builtin_ia32_storeaps256_mask) \
VECTOR_INTRIN(__builtin_ia32_storeaps512_mask) \
VECTOR_INTRIN(__builtin_ia32_storedqu) \
VECTOR_INTRIN(__builtin_ia32_storedqu256) \
VECTOR_INTRIN(__builtin_ia32_storedqudi128_mask) \
VECTOR_INTRIN(__builtin_ia32_storedqudi256_mask) \
VECTOR_INTRIN(__builtin_ia32_storedqudi512_mask) \
VECTOR_INTRIN(__builtin_ia32_storedquhi128_mask) \
VECTOR_INTRIN(__builtin_ia32_storedquhi256_mask) \
VECTOR_INTRIN(__builtin_ia32_storedquhi512_mask) \
VECTOR_INTRIN(__builtin_ia32_storedquqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_storedquqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_storedquqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_storedqusi128_mask) \
VECTOR_INTRIN(__builtin_ia32_storedqusi256_mask) \
VECTOR_INTRIN(__builtin_ia32_storedqusi512_mask) \
VECTOR_INTRIN(__builtin_ia32_storehps) \
VECTOR_INTRIN(__builtin_ia32_storelps) \
VECTOR_INTRIN(__builtin_ia32_storeupd) \
VECTOR_INTRIN(__builtin_ia32_storeupd128_mask) \
VECTOR_INTRIN(__builtin_ia32_storeupd256) \
VECTOR_INTRIN(__builtin_ia32_storeupd256_mask) \
VECTOR_INTRIN(__builtin_ia32_storeupd512_mask) \
VECTOR_INTRIN(__builtin_ia32_storeups) \
VECTOR_INTRIN(__builtin_ia32_storeups128_mask) \
VECTOR_INTRIN(__builtin_ia32_storeups256) \
VECTOR_INTRIN(__builtin_ia32_storeups256_mask) \
VECTOR_INTRIN(__builtin_ia32_storeups512_mask) \
VECTOR_INTRIN(__builtin_ia32_subpd) \
VECTOR_INTRIN(__builtin_ia32_subpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_subpd256) \
VECTOR_INTRIN(__builtin_ia32_subpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_subpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_subps) \
VECTOR_INTRIN(__builtin_ia32_subps128_mask) \
VECTOR_INTRIN(__builtin_ia32_subps256) \
VECTOR_INTRIN(__builtin_ia32_subps256_mask) \
VECTOR_INTRIN(__builtin_ia32_subps512_mask) \
VECTOR_INTRIN(__builtin_ia32_subsd) \
VECTOR_INTRIN(__builtin_ia32_subsd_round) \
VECTOR_INTRIN(__builtin_ia32_subss) \
VECTOR_INTRIN(__builtin_ia32_subss_round) \
VECTOR_INTRIN(__builtin_ia32_tzcnt_u16) \
VECTOR_INTRIN(__builtin_ia32_tzcnt_u32) \
VECTOR_INTRIN(__builtin_ia32_tzcnt_u64) \
VECTOR_INTRIN(__builtin_ia32_ucmpb128_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpb256_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpb512_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpq128_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpq256_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpq512_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpw128_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpw256_mask) \
VECTOR_INTRIN(__builtin_ia32_ucmpw512_mask) \
VECTOR_INTRIN(__builtin_ia32_ucomieq) \
VECTOR_INTRIN(__builtin_ia32_ucomige) \
VECTOR_INTRIN(__builtin_ia32_ucomigt) \
VECTOR_INTRIN(__builtin_ia32_ucomile) \
VECTOR_INTRIN(__builtin_ia32_ucomilt) \
VECTOR_INTRIN(__builtin_ia32_ucomineq) \
VECTOR_INTRIN(__builtin_ia32_ucomisdeq) \
VECTOR_INTRIN(__builtin_ia32_ucomisdge) \
VECTOR_INTRIN(__builtin_ia32_ucomisdgt) \
VECTOR_INTRIN(__builtin_ia32_ucomisdle) \
VECTOR_INTRIN(__builtin_ia32_ucomisdlt) \
VECTOR_INTRIN(__builtin_ia32_ucomisdneq) \
VECTOR_INTRIN(__builtin_ia32_unpckhpd) \
VECTOR_INTRIN(__builtin_ia32_unpckhpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_unpckhpd256) \
VECTOR_INTRIN(__builtin_ia32_unpckhpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_unpckhpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_unpckhps) \
VECTOR_INTRIN(__builtin_ia32_unpckhps128_mask) \
VECTOR_INTRIN(__builtin_ia32_unpckhps256) \
VECTOR_INTRIN(__builtin_ia32_unpckhps256_mask) \
VECTOR_INTRIN(__builtin_ia32_unpckhps512_mask) \
VECTOR_INTRIN(__builtin_ia32_unpcklpd) \
VECTOR_INTRIN(__builtin_ia32_unpcklpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_unpcklpd256) \
VECTOR_INTRIN(__builtin_ia32_unpcklpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_unpcklpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_unpcklps) \
VECTOR_INTRIN(__builtin_ia32_unpcklps128_mask) \
VECTOR_INTRIN(__builtin_ia32_unpcklps256) \
VECTOR_INTRIN(__builtin_ia32_unpcklps256_mask) \
VECTOR_INTRIN(__builtin_ia32_unpcklps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastf128_pd256) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastf128_ps256) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastsd256) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastsd_pd256) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastsi256) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastss) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastss256) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastss_ps) \
VECTOR_INTRIN(__builtin_ia32_vbroadcastss_ps256) \
VECTOR_INTRIN(__builtin_ia32_vcomisd) \
VECTOR_INTRIN(__builtin_ia32_vcomiss) \
VECTOR_INTRIN(__builtin_ia32_vcvtph2ps) \
VECTOR_INTRIN(__builtin_ia32_vcvtph2ps256) \
VECTOR_INTRIN(__builtin_ia32_vcvtph2ps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vcvtph2ps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vcvtph2ps_mask) \
VECTOR_INTRIN(__builtin_ia32_vcvtps2ph) \
VECTOR_INTRIN(__builtin_ia32_vcvtps2ph256) \
VECTOR_INTRIN(__builtin_ia32_vcvtps2ph256_mask) \
VECTOR_INTRIN(__builtin_ia32_vcvtps2ph512_mask) \
VECTOR_INTRIN(__builtin_ia32_vcvtps2ph_mask) \
VECTOR_INTRIN(__builtin_ia32_vcvtsd2si32) \
VECTOR_INTRIN(__builtin_ia32_vcvtsd2si64) \
VECTOR_INTRIN(__builtin_ia32_vcvtsd2usi32) \
VECTOR_INTRIN(__builtin_ia32_vcvtsd2usi64) \
VECTOR_INTRIN(__builtin_ia32_vcvtss2si32) \
VECTOR_INTRIN(__builtin_ia32_vcvtss2si64) \
VECTOR_INTRIN(__builtin_ia32_vcvtss2usi32) \
VECTOR_INTRIN(__builtin_ia32_vcvtss2usi64) \
VECTOR_INTRIN(__builtin_ia32_vcvttsd2si32) \
VECTOR_INTRIN(__builtin_ia32_vcvttsd2si64) \
VECTOR_INTRIN(__builtin_ia32_vcvttsd2usi32) \
VECTOR_INTRIN(__builtin_ia32_vcvttsd2usi64) \
VECTOR_INTRIN(__builtin_ia32_vcvttss2si32) \
VECTOR_INTRIN(__builtin_ia32_vcvttss2si64) \
VECTOR_INTRIN(__builtin_ia32_vcvttss2usi32) \
VECTOR_INTRIN(__builtin_ia32_vcvttss2usi64) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v16qi) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v2df) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v2di) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v2si) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v4hi) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v4sf) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v4si) \
VECTOR_INTRIN(__builtin_ia32_vec_ext_v8hi) \
VECTOR_INTRIN(__builtin_ia32_vec_init_v2si) \
VECTOR_INTRIN(__builtin_ia32_vec_init_v4hi) \
VECTOR_INTRIN(__builtin_ia32_vec_init_v8qi) \
VECTOR_INTRIN(__builtin_ia32_vec_set_v16qi) \
VECTOR_INTRIN(__builtin_ia32_vec_set_v2di) \
VECTOR_INTRIN(__builtin_ia32_vec_set_v4hi) \
VECTOR_INTRIN(__builtin_ia32_vec_set_v4si) \
VECTOR_INTRIN(__builtin_ia32_vec_set_v8hi) \
VECTOR_INTRIN(__builtin_ia32_vextractf128_pd256) \
VECTOR_INTRIN(__builtin_ia32_vextractf128_ps256) \
VECTOR_INTRIN(__builtin_ia32_vextractf128_si256) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd256) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddpd512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps256) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddps512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsd) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsd3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsd3_round) \
VECTOR_INTRIN(__builtin_ia32_vfmaddss) \
VECTOR_INTRIN(__builtin_ia32_vfmaddss3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddss3_round) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd256) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubpd512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps256) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmaddsubps512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vfmsubaddpd128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubaddpd256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubaddpd512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubaddps128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubaddps256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubaddps512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubpd128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubpd256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubpd512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubps128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubps256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfmsubps512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfnmaddpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmaddpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmaddpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmaddps128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmaddps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmaddps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubpd128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubpd256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubpd512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubps128_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubps128_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubps256_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vfnmsubps512_mask3) \
VECTOR_INTRIN(__builtin_ia32_vfrczpd) \
VECTOR_INTRIN(__builtin_ia32_vfrczpd256) \
VECTOR_INTRIN(__builtin_ia32_vfrczps) \
VECTOR_INTRIN(__builtin_ia32_vfrczps256) \
VECTOR_INTRIN(__builtin_ia32_vfrczsd) \
VECTOR_INTRIN(__builtin_ia32_vfrczss) \
VECTOR_INTRIN(__builtin_ia32_vinsertf128_pd256) \
VECTOR_INTRIN(__builtin_ia32_vinsertf128_ps256) \
VECTOR_INTRIN(__builtin_ia32_vinsertf128_si256) \
VECTOR_INTRIN(__builtin_ia32_vp4dpwssd) \
VECTOR_INTRIN(__builtin_ia32_vp4dpwssd_mask) \
VECTOR_INTRIN(__builtin_ia32_vp4dpwssds) \
VECTOR_INTRIN(__builtin_ia32_vp4dpwssds_mask) \
VECTOR_INTRIN(__builtin_ia32_vpcmov) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v16hi256) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v16qi) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v2df) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v2di) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v32qi256) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v4df256) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v4di256) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v4sf) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v4si) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v8hi) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v8sf256) \
VECTOR_INTRIN(__builtin_ia32_vpcmov_v8si256) \
VECTOR_INTRIN(__builtin_ia32_vpcomeqb) \
VECTOR_INTRIN(__builtin_ia32_vpcomeqd) \
VECTOR_INTRIN(__builtin_ia32_vpcomeqq) \
VECTOR_INTRIN(__builtin_ia32_vpcomequb) \
VECTOR_INTRIN(__builtin_ia32_vpcomequd) \
VECTOR_INTRIN(__builtin_ia32_vpcomequq) \
VECTOR_INTRIN(__builtin_ia32_vpcomequw) \
VECTOR_INTRIN(__builtin_ia32_vpcomeqw) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalseb) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalsed) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalseq) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalseub) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalseud) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalseuq) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalseuw) \
VECTOR_INTRIN(__builtin_ia32_vpcomfalsew) \
VECTOR_INTRIN(__builtin_ia32_vpcomgeb) \
VECTOR_INTRIN(__builtin_ia32_vpcomged) \
VECTOR_INTRIN(__builtin_ia32_vpcomgeq) \
VECTOR_INTRIN(__builtin_ia32_vpcomgeub) \
VECTOR_INTRIN(__builtin_ia32_vpcomgeud) \
VECTOR_INTRIN(__builtin_ia32_vpcomgeuq) \
VECTOR_INTRIN(__builtin_ia32_vpcomgeuw) \
VECTOR_INTRIN(__builtin_ia32_vpcomgew) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtb) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtd) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtq) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtub) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtud) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtuq) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtuw) \
VECTOR_INTRIN(__builtin_ia32_vpcomgtw) \
VECTOR_INTRIN(__builtin_ia32_vpcomleb) \
VECTOR_INTRIN(__builtin_ia32_vpcomled) \
VECTOR_INTRIN(__builtin_ia32_vpcomleq) \
VECTOR_INTRIN(__builtin_ia32_vpcomleub) \
VECTOR_INTRIN(__builtin_ia32_vpcomleud) \
VECTOR_INTRIN(__builtin_ia32_vpcomleuq) \
VECTOR_INTRIN(__builtin_ia32_vpcomleuw) \
VECTOR_INTRIN(__builtin_ia32_vpcomlew) \
VECTOR_INTRIN(__builtin_ia32_vpcomltb) \
VECTOR_INTRIN(__builtin_ia32_vpcomltd) \
VECTOR_INTRIN(__builtin_ia32_vpcomltq) \
VECTOR_INTRIN(__builtin_ia32_vpcomltub) \
VECTOR_INTRIN(__builtin_ia32_vpcomltud) \
VECTOR_INTRIN(__builtin_ia32_vpcomltuq) \
VECTOR_INTRIN(__builtin_ia32_vpcomltuw) \
VECTOR_INTRIN(__builtin_ia32_vpcomltw) \
VECTOR_INTRIN(__builtin_ia32_vpcomneqb) \
VECTOR_INTRIN(__builtin_ia32_vpcomneqd) \
VECTOR_INTRIN(__builtin_ia32_vpcomneqq) \
VECTOR_INTRIN(__builtin_ia32_vpcomnequb) \
VECTOR_INTRIN(__builtin_ia32_vpcomnequd) \
VECTOR_INTRIN(__builtin_ia32_vpcomnequq) \
VECTOR_INTRIN(__builtin_ia32_vpcomnequw) \
VECTOR_INTRIN(__builtin_ia32_vpcomneqw) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrueb) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrued) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrueq) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrueub) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrueud) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrueuq) \
VECTOR_INTRIN(__builtin_ia32_vpcomtrueuw) \
VECTOR_INTRIN(__builtin_ia32_vpcomtruew) \
VECTOR_INTRIN(__builtin_ia32_vpconflictdi_128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpconflictdi_256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpconflictdi_512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpconflictsi_128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpconflictsi_256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpconflictsi_512_mask) \
VECTOR_INTRIN(__builtin_ia32_vperm2f128_pd256) \
VECTOR_INTRIN(__builtin_ia32_vperm2f128_ps256) \
VECTOR_INTRIN(__builtin_ia32_vperm2f128_si256) \
VECTOR_INTRIN(__builtin_ia32_vpermi2vard128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2vard256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2vard512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varhi128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varhi256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varhi512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varps128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varq128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varq256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varq512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermi2varqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermil2pd) \
VECTOR_INTRIN(__builtin_ia32_vpermil2pd256) \
VECTOR_INTRIN(__builtin_ia32_vpermil2ps) \
VECTOR_INTRIN(__builtin_ia32_vpermil2ps256) \
VECTOR_INTRIN(__builtin_ia32_vpermilpd) \
VECTOR_INTRIN(__builtin_ia32_vpermilpd256) \
VECTOR_INTRIN(__builtin_ia32_vpermilpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilpd_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilps) \
VECTOR_INTRIN(__builtin_ia32_vpermilps256) \
VECTOR_INTRIN(__builtin_ia32_vpermilps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilps_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarpd) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarpd256) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarpd_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarps) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarps256) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermilvarps_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2vard128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2vard128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2vard256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2vard256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2vard512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2vard512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varhi128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varhi128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varhi256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varhi256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varhi512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varhi512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varpd128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varpd256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varpd512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varps128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varps128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varps256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varps256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varps512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varps512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varq128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varq128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varq256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varq256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varq512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varq512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varqi128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varqi128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varqi256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varqi256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varqi512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpermt2varqi512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vphaddbd) \
VECTOR_INTRIN(__builtin_ia32_vphaddbq) \
VECTOR_INTRIN(__builtin_ia32_vphaddbw) \
VECTOR_INTRIN(__builtin_ia32_vphadddq) \
VECTOR_INTRIN(__builtin_ia32_vphaddubd) \
VECTOR_INTRIN(__builtin_ia32_vphaddubq) \
VECTOR_INTRIN(__builtin_ia32_vphaddubw) \
VECTOR_INTRIN(__builtin_ia32_vphaddudq) \
VECTOR_INTRIN(__builtin_ia32_vphadduwd) \
VECTOR_INTRIN(__builtin_ia32_vphadduwq) \
VECTOR_INTRIN(__builtin_ia32_vphaddwd) \
VECTOR_INTRIN(__builtin_ia32_vphaddwq) \
VECTOR_INTRIN(__builtin_ia32_vphsubbw) \
VECTOR_INTRIN(__builtin_ia32_vphsubdq) \
VECTOR_INTRIN(__builtin_ia32_vphsubwd) \
VECTOR_INTRIN(__builtin_ia32_vplzcntd_128_mask) \
VECTOR_INTRIN(__builtin_ia32_vplzcntd_256_mask) \
VECTOR_INTRIN(__builtin_ia32_vplzcntd_512_mask) \
VECTOR_INTRIN(__builtin_ia32_vplzcntq_128_mask) \
VECTOR_INTRIN(__builtin_ia32_vplzcntq_256_mask) \
VECTOR_INTRIN(__builtin_ia32_vplzcntq_512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmacsdd) \
VECTOR_INTRIN(__builtin_ia32_vpmacsdqh) \
VECTOR_INTRIN(__builtin_ia32_vpmacsdql) \
VECTOR_INTRIN(__builtin_ia32_vpmacssdd) \
VECTOR_INTRIN(__builtin_ia32_vpmacssdqh) \
VECTOR_INTRIN(__builtin_ia32_vpmacssdql) \
VECTOR_INTRIN(__builtin_ia32_vpmacsswd) \
VECTOR_INTRIN(__builtin_ia32_vpmacssww) \
VECTOR_INTRIN(__builtin_ia32_vpmacswd) \
VECTOR_INTRIN(__builtin_ia32_vpmacsww) \
VECTOR_INTRIN(__builtin_ia32_vpmadcsswd) \
VECTOR_INTRIN(__builtin_ia32_vpmadcswd) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52huq128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52huq128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52huq256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52huq256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52huq512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52huq512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52luq128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52luq128_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52luq256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52luq256_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52luq512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmadd52luq512_maskz) \
VECTOR_INTRIN(__builtin_ia32_vpmultishiftqb128_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmultishiftqb256_mask) \
VECTOR_INTRIN(__builtin_ia32_vpmultishiftqb512_mask) \
VECTOR_INTRIN(__builtin_ia32_vpopcountd_v16si) \
VECTOR_INTRIN(__builtin_ia32_vpopcountd_v16si_mask) \
VECTOR_INTRIN(__builtin_ia32_vpopcountq_v8di) \
VECTOR_INTRIN(__builtin_ia32_vpopcountq_v8di_mask) \
VECTOR_INTRIN(__builtin_ia32_vpperm) \
VECTOR_INTRIN(__builtin_ia32_vprotb) \
VECTOR_INTRIN(__builtin_ia32_vprotbi) \
VECTOR_INTRIN(__builtin_ia32_vprotd) \
VECTOR_INTRIN(__builtin_ia32_vprotdi) \
VECTOR_INTRIN(__builtin_ia32_vprotq) \
VECTOR_INTRIN(__builtin_ia32_vprotqi) \
VECTOR_INTRIN(__builtin_ia32_vprotw) \
VECTOR_INTRIN(__builtin_ia32_vprotwi) \
VECTOR_INTRIN(__builtin_ia32_vpshab) \
VECTOR_INTRIN(__builtin_ia32_vpshad) \
VECTOR_INTRIN(__builtin_ia32_vpshaq) \
VECTOR_INTRIN(__builtin_ia32_vpshaw) \
VECTOR_INTRIN(__builtin_ia32_vpshlb) \
VECTOR_INTRIN(__builtin_ia32_vpshld) \
VECTOR_INTRIN(__builtin_ia32_vpshlq) \
VECTOR_INTRIN(__builtin_ia32_vpshlw) \
VECTOR_INTRIN(__builtin_ia32_vtestcpd) \
VECTOR_INTRIN(__builtin_ia32_vtestcpd256) \
VECTOR_INTRIN(__builtin_ia32_vtestcps) \
VECTOR_INTRIN(__builtin_ia32_vtestcps256) \
VECTOR_INTRIN(__builtin_ia32_vtestnzcpd) \
VECTOR_INTRIN(__builtin_ia32_vtestnzcpd256) \
VECTOR_INTRIN(__builtin_ia32_vtestnzcps) \
VECTOR_INTRIN(__builtin_ia32_vtestnzcps256) \
VECTOR_INTRIN(__builtin_ia32_vtestzpd) \
VECTOR_INTRIN(__builtin_ia32_vtestzpd256) \
VECTOR_INTRIN(__builtin_ia32_vtestzps) \
VECTOR_INTRIN(__builtin_ia32_vtestzps256) \
VECTOR_INTRIN(__builtin_ia32_vzeroall) \
VECTOR_INTRIN(__builtin_ia32_vzeroupper) \
VECTOR_INTRIN(__builtin_ia32_wrfsbase32) \
VECTOR_INTRIN(__builtin_ia32_wrfsbase64) \
VECTOR_INTRIN(__builtin_ia32_wrgsbase32) \
VECTOR_INTRIN(__builtin_ia32_wrgsbase64) \
VECTOR_INTRIN(__builtin_ia32_writeeflags_u64) \
VECTOR_INTRIN(__builtin_ia32_wrpkru) \
VECTOR_INTRIN(__builtin_ia32_xabort) \
VECTOR_INTRIN(__builtin_ia32_xbegin) \
VECTOR_INTRIN(__builtin_ia32_xend) \
VECTOR_INTRIN(__builtin_ia32_xorpd) \
VECTOR_INTRIN(__builtin_ia32_xorpd128_mask) \
VECTOR_INTRIN(__builtin_ia32_xorpd256) \
VECTOR_INTRIN(__builtin_ia32_xorpd256_mask) \
VECTOR_INTRIN(__builtin_ia32_xorpd512_mask) \
VECTOR_INTRIN(__builtin_ia32_xorps) \
VECTOR_INTRIN(__builtin_ia32_xorps128_mask) \
VECTOR_INTRIN(__builtin_ia32_xorps256) \
VECTOR_INTRIN(__builtin_ia32_xorps256_mask) \
VECTOR_INTRIN(__builtin_ia32_xorps512_mask) \
VECTOR_INTRIN(__builtin_ia32_xrstor) \
VECTOR_INTRIN(__builtin_ia32_xrstor64) \
VECTOR_INTRIN(__builtin_ia32_xrstors) \
VECTOR_INTRIN(__builtin_ia32_xrstors64) \
VECTOR_INTRIN(__builtin_ia32_xsave) \
VECTOR_INTRIN(__builtin_ia32_xsave64) \
VECTOR_INTRIN(__builtin_ia32_xsavec) \
VECTOR_INTRIN(__builtin_ia32_xsavec64) \
VECTOR_INTRIN(__builtin_ia32_xsaveopt) \
VECTOR_INTRIN(__builtin_ia32_xsaveopt64) \
VECTOR_INTRIN(__builtin_ia32_xsaves) \
VECTOR_INTRIN(__builtin_ia32_xsaves64) \
VECTOR_INTRIN(__builtin_ia32_xtest) \
\
VECTOR_ALIAS(__builtin_ia32_pbroadcastq512_mem_mask, __builtin_ia32_pbroadcastq512_gpr_mask) \
END

static void do_alias(const char* newname, const char* existing)
{
    std::cout << "{\n"
        << "scope_entry_list_t *entry_list = query_in_scope_str(decl_context, uniquestr(\"" << existing << "\"), /* field_path */ NULL);\n"
        << "ERROR_CONDITION(entry_list == NULL, \"Symbol '" << existing << "' should have been declared\",0);\n"
        << "scope_entry_t* orig_sym = entry_list_head(entry_list);\n"
        << "entry_list_free(entry_list);\n"
        << "scope_entry_t* new_sym = new_symbol(decl_context, decl_context->current_scope, uniquestr(\"" << newname << "\"));\n"
        << "new_sym->kind = SK_FUNCTION;"
        << "new_sym->do_not_print = 1;\n"
        << "new_sym->type_information = orig_sym->type_information;\n"
        << "symbol_entity_specs_set_is_builtin(new_sym, 1);\n"
        << "}\n";
}

int main(int, char**)
{
#define VECTOR_INTRIN(X) \
    f<__typeof__(X)>(#X);
#define VECTOR_ALIAS(newname, existing) \
    do_alias(#newname, #existing);
    VECTOR_INTRINSICS_LIST
#undef VECTOR_INTRIN
}
