/*************************************************************************************/
/*      Copyright 2009-2018 Barcelona Supercomputing Center                          */
/*                                                                                   */
/*      This file is part of the NANOS++ library.                                    */
/*                                                                                   */
/*      NANOS++ is free software: you can redistribute it and/or modify              */
/*      it under the terms of the GNU Lesser General Public License as published by  */
/*      the Free Software Foundation, either version 3 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      NANOS++ is distributed in the hope that it will be useful,                   */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU Lesser General Public License for more details.                          */
/*                                                                                   */
/*      You should have received a copy of the GNU Lesser General Public License     */
/*      along with NANOS++.  If not, see <https://www.gnu.org/licenses/>.            */
/*************************************************************************************/

#ifndef _FPGA_WORKER_DECL
#define _FPGA_WORKER_DECL


#include "workdescriptor.hpp"

namespace nanos {
   class FPGAWorker {
      public:
         //We should add some methods for configuration
         static void FPGAWorkerLoop();
         static WD * getFPGAWD(BaseThread *thread);
         static void postOutlineWork( WD * wd );
      private:
         static int _maxPendingWD;
         static int _finishBurst;

   };
} // namespace nanos

#endif

